#ifdef BD
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#ifdef USE_SYS_PROTOS
#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

#undef P_
#endif

static unsigned int	_last_was_phaser;
static unsigned int	_last_time;
static unsigned char	_last_dir;
static int		_borg_counts, _borg_val;

void
bd_phaser(dir)

   unsigned char	dir;
{
   unsigned int		now = mstime();
   int			angdiff;

   if(!_last_time){
      _last_dir = dir;
      _last_time = now;
   }

   if(_last_was_phaser){
/*
      _last_dir = dir;
      _last_time = now;
*/
      _last_was_phaser = 1;
      return;
   }
   _last_was_phaser = 1;

/*
printf("p: delay %d, angdist %d\n", now-_last_time, angdist(dir, _last_dir));
fflush(stdout);
*/

   delay = now - _last_time;
   if(delay > 50){
      _last_dir = dir;
      _last_time = now;
      return;
   }
   angdiff = angdist(dir, _last_dir);
   if(angdiff < 8){
      _last_dir = dir;
      _last_time = now;
      return;
   }

   bd_update(delay, angdiff);

   _last_dir = dir;
   _last_time = now;

   return;
}

void
bd_dir(desc, dir)

   char			*desc;
   unsigned char	dir;
{
   unsigned int		now = mstime();
   int			angdiff, delay;

   if(!_last_time || !_last_was_phaser){
/*
      _last_dir = dir;
      _last_time = now;
*/
      _last_was_phaser = 0;
      return;
   }
   _last_was_phaser = 0;

/*
printf("%s: delay %d, angdist %d\n", desc, now - _last_time, angdist(dir, _last_dir));
fflush(stdout);
*/
   delay = now - _last_time;
   if(delay > 50) {
      _last_dir = dir;
      _last_time = now;
      return;		/* threshold, 50ms */
   }

   angdiff = angdist(dir, _last_dir);

   if(angdiff < 8) {		/* threshold, 11 (8) degrees */
      _last_dir = dir;
      _last_time = now;
      return;
   }

   bd_update(delay, angdiff);

   _last_dir = dir;
   _last_time = now;
}

void
bd_update(delay, angdiff)

   int	delay, angdiff;
{
   /* the greater angdiff and smaller delay, the likelier the player is
      a borg */
   
/*
   printf("delay %d, angdiff %d\n", delay, angdiff);
   fflush(stdout);
*/

   _borg_val += (50-delay) * angdiff;
   _borg_counts ++;
}

int
bd_borg(counts)
   
   int	*counts;
{
   *counts = _borg_counts;

   if(!_borg_counts) return 0;

   /* the maximum possible value here is 51200 */
   return _borg_val / _borg_counts;
}
#endif	/* BD */
