/* daemonII.c 
 * $Date:$
 * 
 */
#include "copyright.h"

#include <stdio.h>
#include <string.h>
#include <values.h>
#include <sys/types.h>
#ifdef SOLARIS2
#include <fcntl.h>
#endif
#include <unistd.h>
#include <sys/stat.h>
#include <netinet/in.h>
#ifdef USE_MMAP
#include <sys/mman.h>
#ifdef sequent
#include <sys/file.h>
#endif
#else
#ifndef MACH
#include <sys/ipc.h>
#include <sys/shm.h>
#endif	/* MACH */
#endif
#include <sys/ioctl.h>
#ifdef ULTRIX
#include <sys/termio.h>
#endif

#include <signal.h>
#include <setjmp.h>
#include <math.h>
#include <errno.h>
#include <limits.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "newstats.h"
#include "../patchlevel.h"
#include "../version.h"

#define PDATA
#include "planets.h"

#include <sys/time.h>
#include <sys/file.h>
#include <sys/wait.h>


#define fuse(X) ((ticks % (X)) == 0)
#define TOURNEXTENSION 15	/* Tmode gone for 15 seconds 8/26/91 TC */
#define NotTmode(X) (!(status->tourn) && ((X - tourntimestamp)/10 > TOURNEXTENSION))
#define SBREBUILDTIME 30	/* base rebuild time in minutes */

#undef PMOVEMENT

/* Run the game */
long rrandom ();
/* long lseek(); */
void doResources ();
int reaper ();
int Flag_Move ();
int move ();
int freemem ();

#ifdef DS
int signal_servers ();
#endif

int nplayers = 0;
int dietime = -1;


static struct itimerval udt;
#ifndef MACH
static int shmid;
#endif

static struct st_new_stats *nstats = NULL, *First_Nstats = NULL;
static int debug = 0;
static int ticks = 0;
static int tourntimestamp = 0;	/* ticks since last Tmode 8/2/91 TC */
static int plfd;
static int glfd;
static long start_Tourn_sec = 0;	/* when we started tmode this game */

jmp_buf env;

char *passwords[MAXPLAYER];	/* daemon knows all- used in reset */
char *teamNames[9] =
{"", "Federation", "Romulans", "", "Klingons",
 "", "", "", "Orions"};
char *teamVerbage[9] =
{"", "has", "have", "", "have", "", "", "", "have"};

/* for confine command */
int cbounds[9][4] =
{
  {0, 0, 0, 0},
  {0, 45000, 55000, 100000},
  {0, 0, 55000, 55000},
  {0, 0, 0, 0},
  {45000, 0, 100000, 55000},
  {0, 0, 0, 0},
  {0, 0, 0, 0},
  {0, 0, 0, 0},
  {45000, 45000, 100000, 100000}
};


static int tcount[MAXTEAM + 1];
unsigned char getbearing ();

int INL_tourn_start = 0;	/* time when the tourney started  RJ INL */
int INL_tournend = 0;		/* True if we are done with the 2 hours RJ INL */
int INL_die_complete = 0;	/* bav - True if game is over and we need to exit */

int Do_Move = 0;		/* Flag for whether or not move() should be called */

int TimeoutStatus = 0;		/* Number of players in non-green status (for timeout) -BM */
double pdistmin = MAXFLOAT;	/* (avoid int overflow warning -tsh) jmn */
	/* min distance from a bad guy */
	/* we look at this to figure out how close we are to 
	   being in green alert so we can relax ALL in green alert
	   restriction */

struct memory *sharedMemory;	/* so we can get the waitq -tsh */

#if defined(USE_MMAP) && defined(USE_VALLOC)
#define memalign(align, len) valloc(len)
#endif

#ifdef SHORT_PACKETS
int arg[8];
#endif

main (argc, argv)
     int argc;
     char **argv;
{
  register int i;
#ifndef USE_MMAP
#ifndef MACH
  int shmemKey = PKEY;
  struct shmid_ds smbuf;
#endif	/* MACH */
#endif	/* USE_MMAP */
  int x = 0, k = 0;
  if (argc > 1)
    debug = atoi (argv[1]);

  fprintf (stderr, "Daemon says 'hello!'\n");
  srrandom (getpid ());

  if (getenv ("NETREKDIR"))
    {
      if (chdir (getenv ("NETREKDIR")) != 0)
	fprintf (stderr, "couldn't chdir to $NETREKDIR:%s",
		 getenv ("NETREKDIR"));
      if (chdir (NETREKDIR) != 0)
	{
	  perror ("chdir error");
	  fprintf (stderr, "couldn't chdir to NETREKDIR:%s", NETREKDIR);
	}
    }

  readsysdefaults ();
  if (!debug)
#ifndef NSIG
#define NSIG 32
#endif
    {
      for (i = 0; i < NSIG; i++)
	{
#ifdef DEBUG
	  if (i == SIGSEGV || i == SIGBUS)
	    continue;
#endif
	  (void) SIGNAL (i, freemem);
	}
      SIGNAL (SIGSTOP, SIG_DFL);	/* accept SIGSTOP? 3/6/92 TC */
      SIGNAL (SIGTSTP, SIG_DFL);	/* accept SIGTSTP? 3/6/92 TC */
      SIGNAL (SIGCONT, SIG_DFL);	/* accept SIGCONT? 3/6/92 TC */
/*      detach(); */
    }

  /* Kill any existing segments */
#ifdef USE_MMAP
  {
    FILE *fp;
    int len, pagesize;
    extern int errno;
    if (unlink ("sharedMem") < 0)
      {
	perror ("daemon: unlink shared memory file failed (this is ok)");
      }
    fp = fopen ("sharedMem", "w+");
    if (fp == NULL)
      {
	perror ("daemon: can't open mmap file");
	exit (1);
      }
    len = sizeof (struct memory);
    pagesize = getpagesize ();
    if ((len % pagesize) != 0)
      len += pagesize - (len % pagesize);
    if (ftruncate (fileno (fp), len) < 0)
      {
	perror ("daemon: ftruncate mmap file");
      }
    sharedMemory = (struct memory *) memalign (pagesize, len);
    if (sharedMemory == NULL)
      {
	perror ("daemon: memalign failed");
	exit (1);
      }
    errno = 0;
    mmap (sharedMemory, len, PROT_READ | PROT_WRITE, MAP_FIXED | MAP_SHARED,
	  fileno (fp), 0);
    if (errno != 0)
      {
	perror ("daemon: mmap failed");
	exit (1);
      }
    /* zero out the memory just in case */
    bzero (sharedMemory, len);
    fclose (fp);
  }
#else
#ifndef MACH

  shmid = shmget (shmemKey, sizeof (struct memory), IPC_CREAT | IPC_EXCL | 0777);
  if (shmid < 0)
    {
      perror ("daemonII: can't open shared memory");
      exit (1);
    }

  sharedMemory = (struct memory *) shmat (shmid, 0, 0);
#else
  {
#include <mach.h>
#include <servers/netmemory.h>
#include <servers/netname.h>
    extern port_t name_server_port;
    port_t netmemory_port;
    port_t obj, mem_obj, mem_ctl;
    kern_return_t ret;
    ret = netname_look_up (name_server_port, "", "netmemoryserver",
			   &netmemory_port);
    if (ret != KERN_SUCCESS)
      {
	mach_error ("getting netmemoryserver port", ret);
	exit (1);
      }

    ret = netmemory_create (netmemory_port, sizeof (struct memory), &obj,
			    &mem_ctl);
    if (ret != NETMEMORY_SUCCESS)
      {
	mach_error ("netmemory_create", ret);
	exit (1);
      }

    ret = netmemory_cache (netmemory_port, obj, &mem_obj);
    if (ret != NETMEMORY_SUCCESS)
      {
	mach_error ("netmemory_cache", ret);
	(void) netmemory_destroy (mem_ctl);
	exit (1);
      }
    ret = netname_check_in (name_server_port, "netrek", task_self (), mem_obj);
    if (ret != NETNAME_SUCCESS)
      {
	mach_error ("Checkin In netrek port", ret);
	exit (1);
      }

    ret = vm_map (task_self (), &sharedMemory, sizeof (struct memory), 0, 1,
		  mem_obj, 0, 0, VM_PROT_READ | VM_PROT_WRITE,
		  VM_PROT_READ | VM_PROT_WRITE, VM_INHERIT_NONE);
    if (ret != KERN_SUCCESS)
      {
	mach_error ("vm_map", ret);
	(void) netmemory_destroy (mem_ctl);
	exit (1);
      }
  }
#endif
#endif
  if (sharedMemory == (struct memory *) -1)
    {
      perror ("shm attach");
      exit (1);
    }
  players = sharedMemory->players;
  torps = sharedMemory->torps;
  plasmatorps = sharedMemory->plasmatorps;
  status = sharedMemory->status;
  planets = sharedMemory->planets;
  phasers = sharedMemory->phasers;
  mctl = sharedMemory->mctl;
  messages = sharedMemory->messages;
  teams = sharedMemory->teams;
  INLteams = sharedMemory->INLteams;
  INLteamschosen = sharedMemory->INLteamschosen;
  captains = sharedMemory->captains;
  pausereq = sharedMemory->pausereq;
  otlenreq = sharedMemory->otlenreq;
  gamelenreq = sharedMemory->gamelenreq;
  continuereq = sharedMemory->continuereq;
  confinereq = sharedMemory->confinereq;
  timeoutreq = sharedMemory->timeoutreq;
  startreq = sharedMemory->startreq;
  restartreq = sharedMemory->restartreq;
  newgalaxyreq = sharedMemory->newgalaxyreq;
  regreq = sharedMemory->regreq;
  INL_timeleft = &(sharedMemory->INL_timeleft);
  INL_period = &(sharedMemory->INL_period);
  resetInProgress = &(sharedMemory->resetInProgress);
  teamname = sharedMemory->teamname;
  sharedMemory->Wait_Queue[0].Second_Queue = MAXQUEUE / 2;
  setarmyreq = sharedMemory->setarmyreq;
  initial_armies = &(sharedMemory->initial_armies);

  *resetInProgress = 0;
  *initial_armies = PLARMY;

  INLteams[0] = FED;		/* jmn- move these outside resetparams */
  INLteams[1] = ROM;
  resetparams ();

  cleanreservations ();

  for (i = 0; i <= MAXTEAM; i++)
    {
      teams[i].s_turns = 0;
    }

  for (i = 0; i < MAXPLAYER; i++)
    {
      players[i].p_status = PFREE;
      players[i].p_stats.st_tticks = 1;
      players[i].p_no = i;
    }

  resetglobals ();

  doResources (1);

#ifdef PMOVEMENT
  pinit ();
#endif

  (void) SIGNAL (SIGCHLD, reaper);

  (void) SIGNAL (SIGALRM, Flag_Move);
  udt.it_interval.tv_sec = 0;
  udt.it_interval.tv_usec = UPDATE;
  udt.it_value.tv_sec = 0;
  udt.it_value.tv_usec = UPDATE;
  (void) setitimer (ITIMER_REAL, &udt, (struct itimerval *) 0);

  (void) setjmp (env);
/*    check_load(); */

  while (1)
    {
      PAUSE (SIGALRM);
      if (debug)
	{
	  if (!(++x % 50))
	    printf ("Mark %d\n", x);
	}
      if (Do_Move)
	{
	  move ();
	  Log_Messages ();	/* note, INL now logs ALL messages */
	  Do_Move = 0;
	}
    }
}


resetglobals ()
{
  plfd = open (PLFILE, O_RDWR | O_CREAT, 0744);


  glfd = open (GLOBAL, O_RDWR, 0744);
  if (glfd < 0)
    {
      fprintf (stderr, "No global file.  Resetting all stats\n");
      status->time = 0;
    }
  else
    {
      if (read (glfd, (char *) status, sizeof (struct status)) !=
	  sizeof (struct status))
	{
	  fprintf (stderr, "Global file wrong size.  Resetting all stats\n");
	  status->time = 0;
	  /*bzero((char *) status, sizeof(struct status)); */
	}
    }
  if (status->time == 0)
    {
      /* Start all stats at 1 to prevent overflow */
      status->time = 1;
      status->timeprod = 1;
      status->planets = 1;
      status->armsbomb = 1;
      status->kills = 1;
      status->losses = 1;
      status->armsogged = 1;
      status->armsdel = 1;
    }

  status->active = 0;
  status->wait = 0;
  status->count = 0;
  status->request = 0;
  status->gameup = 1;
  status->tourn = 0;
  status->gamepaused = 0;
  status->firstpickpassed = 0;
}


/* this should be just enough to prepare for a new game assuming that we 
   just finished one */
resetparams ()
{
  start_Tourn_sec = 0;
  INL_tourn_start = 0;		/* time when the tourney started  RJ INL */
  INL_tournend = 0;		/* True if we are done with the 2 hours RJ INL */
  INL_die_complete = 0;		/* bav - True if game is over and we need to exit */

  INLteamschosen[0] = INLteamschosen[1] = 0;
  regreq[0] = regreq[1] = 0;	/* jmn */
  captains[0] = captains[1] = -1;
  pausereq[0] = pausereq[1] = 0;
  gamelenreq[0] = gamelenreq[1] = 0;
  otlenreq[0] = otlenreq[1] = 0;
  continuereq[0] = continuereq[1] = 0;
  startreq[0] = startreq[1] = 0;
  restartreq[0] = restartreq[1] = 0;
  timeoutreq[0] = timeoutreq[1] = to_num;	/* jmn */
  newgalaxyreq[0] = newgalaxyreq[1] = 0;
  setarmyreq[0] = setarmyreq[1] = 0;
  *INL_period = 0;
}


cleanreservations ()
{
  int i, j;
  int resf;
  int tmp, maxindex;
  time_t maxstart;
  struct tm *tm_start;
  struct timeval tv_date;
  struct resentry res[MAXRES];

  gettimeofday (&tv_date, (struct timezone *) 0);

/* first we read in all the ones we have so far */
  i = 0;
  j = 0;
  resf = open (RESERVATIONS, O_RDONLY | O_CREAT, 0744);
  if (resf <= 0)
    {
      fprintf (stderr, "daemon: Error %d opening reservations file... sorry\n", resf);
      close (resf);
      return -1;
    }

  while (read (resf, (char *) &res[i], sizeof (struct resentry)) != NULL &&
	 i < MAXRES)
    {
      /* dump old reservations */
      if (tv_date.tv_sec > res[i].end_time)
	{
	  fprintf (stderr, "daemon: dump entry %d - %s\n", i, res[i].team_name);
	}
      else
	{
	  i++;
	}
    }
  close (resf);

  resf = open (RESERVATIONS, O_WRONLY | O_TRUNC);
  if (resf < 0)
    {
      fprintf (stderr, "daemon: Error %d opening reservation file for write.. aborting\n", resf);
      close (resf);
      return -1;
    }
  lseek (resf, 0, SEEK_SET);
  for (j = 0; j < i; j++)
    {
      /* here we do bogus sorting of what we write - after enough daemon
         restarts things will be nicely sorted */
      if (j < (i - 1))
	{
	  if (res[j].start_time > res[j + 1].start_time)
	    {
	      tmp = write (resf, (char *) &res[j + 1], sizeof (struct resentry));
	      tmp = write (resf, (char *) &res[j], sizeof (struct resentry));
	      j++;
	    }
	  else
	    {
	      tmp = write (resf, (char *) &res[j], sizeof (struct resentry));
	    }
	}
      else
	{
	  tmp = write (resf, (char *) &res[j], sizeof (struct resentry));
	}
      if (tmp < 0)
	{
	  fprintf (stderr, "daemon: Error %d writing reservation file.. aborting\n", tmp);
	  close (resf);
	  return -1;
	}
    }
  close (resf);
}

Flag_Move ()
{

#ifdef HOSED_SIGNALHANDLERS
  /* some goofy systems need the signal handler reset frequently. sigh */
  (void) SIGNAL (SIGALRM, Flag_Move);
#endif
  if (debug && Do_Move)
    fprintf (stderr, "Warning: missed a update!\n");
  Do_Move = 1;
}

detach ()
{
  int fd;

#ifdef SOLARIS2
  return;
#else
  fd = open ("/dev/tty", O_RDWR, 0);
  if (fd < 0)
    return;
  (void) ioctl (fd, TIOCNOTTY, (char *) NULL);
  (void) close (fd);
#endif
}


int 
tournamentMode ()
/* Return 1 if tournament mode, 0 otherwise.
 * This function only used to determine if we should be recording stats.
 */
{
  int i, teams[16];
  struct player *p;

  if (INL_tourn_start && (INL_tourn_start <= ticks))
    return (1);
  return (0);
}

realNumShips (owner)
{
  int i, num = 0;
  struct player *p;

  for (i = 0, p = players; i < MAXPLAYER; i++, p++)
    if (p->p_status != PFREE && p->p_status != POBSERV &&
	p->p_team == owner)
      num++;
  return (num);
}

move ()
{
  static int oldtourn = 0;
  static int oldmessage;
  char buf[160];		/* lets be very very safe here */

  if (Game_Paused () != 0)
    {
#ifdef DS
      signal_servers ();
#endif
      return;
    }

  if (++ticks == dietime)
    {				/* no player for 1 minute. kill self */
      if (debug)
	{
	  fprintf (stderr, "Ho hum.  1 minute, no activity...\n");
	}
      else
	{
	  fprintf (stderr, "Self-destructing the daemon!\n");
	  freemem (0, 0, NULL);
	}
    }
  if ((gamelenreq[0] == gamelenreq[1]) && (otlenreq[0] == otlenreq[1]) &&
      gamelenreq[0] != 0 && otlenreq[0] != 0)
    {
      sprintf (buf, "A game of %d min with %d min overtime is approved.",
	       gamelenreq[0], otlenreq[0]);
      INL_overtime_length = 600 * otlenreq[0];
      INL_game_length = 600 * gamelenreq[0];
      gamelenreq[0] = 0;
      otlenreq[0] = 0;
      gamelenreq[1] = 0;
      otlenreq[1] = 0;
      pmessage (buf, 0, MALL, "");
    }

  if (update_sys_defaults ())
    {
      /* This message does 2 things:
         * First, it tells the players that the system defaults have in fact
         *  changed.
         * Secondly, it triggers the ntserv processes to check the new defaults.
       */
      pmessage ("Loading new server configuration.", 0, MALL, "GOD->ALL");
    }

  if (tournamentMode ())
    {
      if (!oldtourn)
	{
	  switch (oldmessage = (rrandom () % 8))
	    {
	    case 0:
	      pmessage ("A dark mood settles upon the galaxy", 0, MALL, "GOD->ALL");
	      break;
	    case 1:
	      pmessage ("Political pressure to expand is rising", 0, MALL, "GOD->ALL");
	      break;
	    case 2:
	      pmessage ("Border disputes break out as political tensions increase!", 0, MALL, "GOD->ALL");
	      break;
	    case 3:
	      pmessage ("Galactic superpowers seek to colonize new territory!", 0, MALL, "GOD->ALL");
	      break;
	    case 4:
	      pmessage ("'Manifest Destiny' becomes motive in galactic superpower conflict!", 0, MALL, "GOD->ALL");
	      break;
	    case 5:
	      pmessage ("Diplomat insults foriegn emperor's mother and fighting breaks out!", 0, MALL, "GOD->ALL");
	      break;
	    case 6:
	      pmessage ("Dan Quayle declares self as galactic emperor and chaos breaks out!", 0, MALL, "GOD->ALL");
	      break;
	    default:
	      pmessage ("Peace parties have been demobilized, and fighting ensues.", 0, MALL, "GOD->ALL");
	      break;
	    }
	  send_start_message ();
	  new_stats ();
	  *INL_period = 0;
	  doResources (0);
	}
      oldtourn = 1;
      status->tourn = 1;
      status->time++;
      /* make sure these get reset */
      confinereq[0] = 0;
      confinereq[1] = 0;
      tourntimestamp = ticks;
    }
  else
    {
      if (oldtourn)
	{
	  tourntimestamp = ticks;	/* record end of Tmode 8/2/91 TC */
	  switch (oldmessage)
	    {
	    case 0:
	      pmessage ("A new day dawns as the oppressive mood lifts", 0, MALL, "GOD->ALL");
	      break;
	    case 1:
	      pmessage ("The expansionist pressure subsides", 0, MALL, "GOD->ALL");
	      break;
	    case 2:
	      pmessage ("Temporary agreement is reached in local border disputes.", 0, MALL, "GOD->ALL");
	      break;
	    case 3:
	      pmessage ("Galactic governments reduce colonization efforts.", 0, MALL, "GOD->ALL");
	      break;
	    case 4:
	      pmessage ("'Manifest Destiny is no longer a fad.' says influential philosopher.", 0, MALL, "GOD->ALL");
	      break;
	    case 5:
	      pmessage ("Diplomat apologizes to foreign emperor's mother and invasion is stopped!", 0, MALL, "GOD->ALL");
	      break;
	    case 6:
	      pmessage ("Dan Quayle is locked up and order returns to the galaxy!", 0, MALL, "GOD->ALL");
	      break;
	    default:
	      pmessage ("The peace party has reformed, and is rallying for peace", 0, MALL, "GOD->ALL");
	      break;
	    }
	}
      oldtourn = 0;
      status->tourn = 0;
    }
  if (fuse (PLAYERFUSE))
    {
      udplayers ();
    }
  if (fuse (TORPFUSE))
    {
      udtorps ();
    }
  if (fuse (PLASMAFUSE))
    {
      udplasmatorps ();
    }
  if (fuse (PHASERFUSE))
    {
      udphaser ();
    }
  if (fuse (CLOAKFUSE))
    {
      udcloak ();
    }


#ifdef DS
  /* not sure where's the best place to put this (or even if it matters).
     If here, we tell the ntserv processes to update now while the daemon
     putters through the remaining non-essential updates */
  signal_servers ();
#endif

  if (fuse (TEAMFUSE))
    {
      teamtimers ();
    }
  if (fuse (PLFIGHTFUSE))
    {
      plfight ();
    }
  if (fuse (BEAMFUSE))
    {
      beam ();
    }
#ifdef PMOVEMENT
  if (fuse (PMOVEFUSE))
    {				/* call planet movement 10/10/91 TC */
      pmove ();
    }
#endif
  if (fuse (SYNCFUSE))
    {
      save_planets ();
    }
  if (fuse (PLANETFUSE))
    {
      udplanets ();
    }
  if (fuse (CHECKLOADFUSE))
    {
      /*check_load(); this causes blocked pipes when too many processes */
      /* are running */
    }

  if (fuse (ONE))
    {				/* once a minute */
      udteams ();
    }

  if (restartreq[0] && restartreq[1])
    {
      pmessage ("Game restarting.  Teams should be reselected", 0, MALL, "");
      if (status->tourn)
	resettstats ();		/* this should stop tac stats from getting hosed */
      INLteamschosen[0] = INLteamschosen[1] = 0;
      restartreq[0] = restartreq[1] = 0;
      startreq[0] = startreq[1] = 0;
      pausereq[0] = pausereq[1] = 0;
      continuereq[0] = continuereq[1] = 0;
      INL_tourn_start = INL_tournend = 0;
      *INL_period = 0;
      return;
    }

  if (setarmyreq[0] > 0 && (setarmyreq[0] == setarmyreq[1]))
    {
      sprintf (buf, "Initial army number of %d approved.", setarmyreq[0]);
      pmessage (buf, 0, MALL, "");

      if (*initial_armies == setarmyreq[0])
	{
	  setarmyreq[0] = setarmyreq[1] = 0;
	  return;
	}

      *initial_armies = setarmyreq[0];
      setarmyreq[0] = setarmyreq[1] = 0;

      /* on second thought, maybe we shouldn't force this on them... */
      /*newgalaxyreq[0] = newgalaxyreq[1] = 1; */

      setarmies (*initial_armies);
      return;
    }

  if (newgalaxyreq[0] && newgalaxyreq[1])
    {
      if (status->tourn)
	resettstats ();		/* this should stop tac stats from getting hosed */
      resetgalaxy ();
      return;
    }

  if (status->tourn)
    {
      *INL_timeleft = ticks - INL_tourn_start;
      if (*INL_period == 0)
	*INL_timeleft = INL_game_length - *INL_timeleft;
      else
	*INL_timeleft = INL_game_length + INL_overtime_length - *INL_timeleft;

      if ((*INL_timeleft >= TWENTY) && (!(*INL_timeleft % TWENTY)))
	send_time_update (*INL_timeleft, *INL_period);
      else if (*INL_timeleft <= TEN && *INL_timeleft >= (FIVE + ONE)
	       && (!(*INL_timeleft % (ONE * 2))))
	send_time_update (*INL_timeleft, *INL_period);
      else if ((*INL_timeleft <= FIVE) && (*INL_timeleft >= ONE) &&
	       (!(*INL_timeleft % ONE)))
	send_time_update (*INL_timeleft, *INL_period);
      else if ((*INL_timeleft < ONE) && (!(*INL_timeleft % (ONE / 6))))
	send_time_update (*INL_timeleft, *INL_period);

      if ((*INL_timeleft) == 0)
	{
	  (*INL_period)++;
	  switch (*INL_period)
	    {
	    case 0:
	      break;
	    case 1:		/* end of Regulation play */
	      obliterate (0, KTOURNEND);
	      INL_tournend = 1;
	      pmessage ("**** Regulation play ended.", 0, MALL, "");
	      checkwin ();
	      if (status->tourn)
		{
		  pmessage ("**** Sudden death OT started.", 0, MALL, "");
		  send_time_update (INL_overtime_length, *INL_period);
		  new_stats ();
		}
	      else
		{
		  resettourn ();
		  return;
		}
	      break;
	    default:		/* cases over 2 are extra OT periods */
	    case 2:		/* end of OT */
	      checkwin ();	/* double check tie,extend game if in playoff mode */
	      if (!status->tourn)
		{
		  pmessage ("**** Game is a draw.", 0, MALL, "");
		  resettourn ();
		  return;
		  break;
		}
	      else
		{
		  pmessage ("**** NO TIES!", 0, MALL, "");
		  pmessage ("**** THERE CAN BE ONLY ONE!", 0, MALL, "");
		  pmessage ("**** EXTRA Sudden death OT started.", 0, MALL, "");
		  send_time_update (INL_overtime_length, *INL_period);
		  /* extend the game... */
		  *INL_timeleft = INL_game_length + INL_overtime_length
		    + INL_overtime_length / 2 * ((*INL_period) - 2)
		    - *INL_timeleft;
		}
	    }
	}
    }
  else
    {
      if (startreq[0] && startreq[1])
	{
	  startreq[0] = startreq[1] = 0;
	  INL_tourn_start = ticks + ONE;
	  obliterate (2, KSHIP);
	  send_about_to_start ();
	}
    }
  if (nstats && ticks - nstats->age > NSTATS_TICKS_PER)
    {
      new_stats ();
    }
}


/* set all planets to have numarmies armies */
setarmies (numarmies)
     int numarmies;
{
  int i;

  for (i = 0; i < MAXPLANETS; i++)
    {
      planets[i].pl_armies = numarmies;
    }
}

resetgalaxy ()
{
  newgalaxyreq[0] = newgalaxyreq[1] = 0;
  doResources (1);
  pmessage ("Game restarting with new galaxy.  Teams should be reselected", 0, MALL, "");
  INLteamschosen[0] = INLteamschosen[1] = 0;
  restartreq[0] = restartreq[1] = 0;
  startreq[0] = startreq[1] = 0;
  pausereq[0] = pausereq[1] = 0;
  continuereq[0] = continuereq[1] = 0;
  INL_tourn_start = INL_tournend = 0;
  *INL_period = 0;
}

send_about_to_start ()
{
  char buf[128];

  INLteams[0] = INLteamschosen[0];
  INLteams[1] = INLteamschosen[1];

  sprintf (buf, "Teams are   %s (Home): %s,   %s (Away): %s",
	   teamname[0], teamshort[INLteamschosen[0]],
	   teamname[1], teamshort[INLteamschosen[1]]);
  pmessage (buf, 0, MALL, "");
  sprintf (buf, "Current INL Game Time: %d min regulation, %d min overtime",
	   INL_game_length / 600, INL_overtime_length / 600);
  pmessage (buf, 0, MALL, "");
  pmessage ("Teams chosen.  Game will start in 1 minute.", 0, MALL, "");
  pmessage ("----------- Game will start in 1 minute -------------", 0, MALL, "");
  pmessage ("----------- Game will start in 1 minute -------------", 0, MALL, "");


}

send_start_message ()
{
  char buf[128];
  char tmp[80];
  int h;
  struct player *j;
  struct timeval tv;
  struct tm *tp;
  char *ap;

  INLteams[0] = INLteamschosen[0];
  INLteams[1] = INLteamschosen[1];

  sprintf (buf, "%s, patchlevel %d", version, PATCHLEVEL);
  pmessage (buf, 0, MALL, "");
  sprintf (buf, "INL Tournament starting now. %s(%s) vs. %s(%s).",
	   teamname[0], teamshort[INLteams[0]],
	   teamname[1], teamshort[INLteams[1]]);
  pmessage (buf, 0, MALL, "");
  sprintf (buf, "INL Game Time: %d min regulation, %d min overtime",
	   INL_game_length / 600, INL_overtime_length / 600);
  pmessage (buf, 0, MALL, "");

  gettimeofday (&tv, (struct timezone *) 0);
  start_Tourn_sec = tv.tv_sec;	/* use this in log_message to give time elapsed */
  tp = localtime (&tv.tv_sec);
  ap = asctime (tp);

  strncpy (tmp, ap + 4, 15);
  *(tmp + 15) = '\0';
  sprintf (buf, "%s is the starting time of t-mode play.", tmp);
  pmessage (buf, 0, MALL, "");


  resettstats ();		/* obliteration with player stats reset */

#ifdef notdef
  /* clear torps and plasmas out */
  bzero (torps, sizeof (struct torp));
  bzero (plasmatorps, sizeof (struct plasmatorp));
  /* this really _SHOULD_ be an obliterate... */
  for (h = 0, j = &players[0]; h < MAXPLAYER; h++, j++)
    {
      if (j->p_status == PFREE)
	continue;
      j->p_status = PEXPLODE;
      j->p_whydead = KTOURNSTART;
      if (j->p_ship.s_type == STARBASE)
	j->p_explode = 2 * SBEXPVIEWS / PLAYERFUSE;
      else
	j->p_explode = 10 / PLAYERFUSE;
      j->p_ntorp = 0;
      j->p_nplasmatorp = 0;
      j->p_hostile = (FED | ROM | ORI | KLI);
    }
#endif

}

send_time_update (INL_ticks, INL_period)
     int INL_ticks;
     int INL_period;
{
  char buf[128];
  char *p = "xyzzy";

  switch (INL_period)
    {
    case 0:
      p = "Regulation play";
      break;
    case 1:
      p = "Overtime";
      break;
    }

  if (INL_ticks > 600)
    {
      sprintf (buf, "**** %d minutes left in %s ****", INL_ticks / 600, p);
    }
  else
    {
      sprintf (buf, "**** %d seconds left in %s ****", INL_ticks / 10, p);
    }
  pmessage (buf, 0, MALL, "");
}

resettstats ()
{
  /* this should be something more clever but what the hell */
  /* so as is ...it only makes sure tac isn't screwed  - jmn */
  obliterate (1, KTOURNEND);

  resetstats ();		/* getting alittle smarter - jn */

}


resetstats ()
{
  int i;

  for (i = 0; i <= MAXTEAM; i++)
    teams[i].s_turns = 0;

  for (i = 0; i < MAXPLAYER; i++)
    resetplayerstats (i);	/* reset player #i, hopefully clever enough */
}


resetplayerstats (pnum)
     int pnum;
{
  struct player *j;

  if (pnum < 0 || pnum >= MAXPLAYER)
    {
      fprintf (stderr, "Bad player index to resetplayerstats() %d\n", pnum);
      fflush (stderr);
      return;
    }
  j = &players[pnum];
  bzero (&(j->p_stats), sizeof (struct stats));

  /* initial player state as given in getname */
  j->p_stats.st_tticks = 1;
  j->p_stats.st_tsbticks = 1;
  j->p_stats.st_flags = ST_INITIAL;

  /* reset stats which are not in stats */
  j->p_genoplanets = 0;
  j->p_genoarmsbomb = 0;
  j->p_planets = 0;
  j->p_armsbomb = 0;
}


/* save everything */
savetourn ()
{
  int i;
  struct player *j;

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (j->p_status != PFREE)
	saveplayer (j);
    }

  status->count = 0;
  save_planets ();
  close (glfd);			/* close so we won't confuse things during end_tourney */
  close (plfd);
  print_inl_stats ();
  close_inl_messagelog ();
}

/* register tournament, this should clear old stats in files */
regtourn (player)
     int player;
{
  char buf[512];

  if (regreq[0] && regreq[1])
    {
      sprintf (buf, "%s %s blah", END_SCRIPT, (player ? "player" : "nukeem"));
      system (buf);		/* this ain't varargs */
    }
  else
    {
      sprintf (buf, "%s %s", END_SCRIPT, (player ? "player" : "nukeem"));
      system (buf);
    }
}

/* Game over, man!! - jn */
resettourn ()
{
  pmessage ("-----------   Saving Tournament Stats   -------------", 0, MALL, "");
  *resetInProgress = 1;

  /* don't interupt this whole damn process */
  (void) SIGNAL (SIGALRM, SIG_IGN);

  /* clear the players */
  obliterate (1, KSHIP);

  /* save and process the tournament */
  savetourn ();
  rememberpasswords ();
  regtourn (0);

  /* reset for next tournament */
/*     resetteams(); leave them on same teams they were on - jmn  */
  resetstats ();
  resetparams ();		/* must be under resetteams */
#ifdef REENTER
  reenterplayers ();
#else
  resetplayerfile ();
#endif
  resetglobals ();
  reset_new_stats ();

  (void) SIGNAL (SIGALRM, Flag_Move);

  *resetInProgress = 0;
  pmessage ("-----------   Tournament Stats Reset    -------------", 0, MALL, "");
}


/* for some reason a few players are managing to sneak into the
   ** game without having a team reset, I think this is because
   ** team reset occurs near the end of the tournament reset and
   ** some players who are already in POUTFIT are managing to sneak
   ** back into the game after the obliteration.
   **
   ** Doesn't matter to us, as long as we force them into the
   ** the correct team.  A better solution would be to fix this
   ** in getentry (shiver), will work on that later. - jn
 */
resetteams ()
{
  int i;
  struct player *j;
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (j->p_status == PFREE)
	continue;

      if (j->p_team == INLteams[0])
	j->p_team = FED;
      else
	j->p_team = ROM;
    }
}

/* need to store passwords in order to resave them later,
   ** after the player file is nuked - mega disk access from hell
 */
rememberpasswords ()
{
  int pfd;
  int i;
  struct player *j;
  struct statentry player;
  int entries;
  struct stat buf;
  char *strdup ();
  int fd;

  fd = open (PLAYERFILE, O_RDWR, 0644);
  if (fd < 0)
    {
      /* we can't survive without a player file */
      fprintf (stderr, "FATAL ERROR: Can't open PLAYERFILE in rememberpasswords().\n");
      fflush (stderr);
      freemem (0, 0, NULL);
    }

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (j->p_status == PFREE)
	{
	  continue;
	}

      lseek (fd, j->p_pos * sizeof (struct statentry), 0);
      if (read (fd, (char *) &player, sizeof (struct statentry)) !=
	  sizeof (struct statentry))
	{
	  fprintf (stderr, "Stat entry wrong size for %d, may be hosed.\n", i);
	  fflush (stderr);
	}
      passwords[i] = strdup (player.password);
    }

  close (fd);
}

/* the playerfile was not nuked, but we need to reset the stats of
   ** everyone so only 1 INL game is ever counted. jn
 */
resetplayerfile ()
{
  int pfd;
  int i;
  struct player *j;
  struct stats playerstat;
  struct stats *playerstats;
  int entries;
  struct stat buf;

  pfd = open (PLAYERFILE, O_RDWR | O_CREAT, 0644);

  if (pfd < 0)
    {
      /* we can't survive without a player file */
      fprintf (stderr, "FATAL ERROR: Can't open PLAYERFILE in resetplayerfile().\n");
      fflush (stderr);
      freemem (0, 0, NULL);
      exit (0);			/* should never reach this point */
    }

  /* sort of a learn by doing course in I/O for me... hopefully
     ** this is all correct... - jn
   */
  fstat (pfd, &buf);
  entries = buf.st_size / sizeof (struct statentry);

  /* the same as resetplayerstats() */
  playerstats = &playerstat;
  bzero (playerstats, sizeof (struct stats));
  playerstats->st_tticks = 1;
  playerstats->st_tsbticks = 1;
  playerstats->st_flags = ST_INITIAL;

  /* disk access from hell */
  for (i = 0; i < entries; i++)
    {
      lseek (pfd, 32 + i * sizeof (struct statentry), 0);
      write (pfd, (char *) playerstats, sizeof (struct stats));
    }

  close (pfd);
}

/* the playerfile was nuked, need to reenter those players who are
   already alive - jn */
reenterplayers ()
{
  int pfd;
  int i;
  struct player *j;
  struct statentry player;
  int entries;
  struct stat buf;

  /* ugh, getname tricks... shoot me, but it looks necessary */
  pfd = open (PLAYERFILE, O_RDWR | O_CREAT, 0644);
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (j->p_status == PFREE)
	continue;

      j->p_name[15] = '\0';	/* names must be no more than 15 characters */
      strcpy (player.name, j->p_name);
      strcpy (player.password, passwords[i]);
      bzero (&player.stats, sizeof (struct stats));
      player.stats.st_tticks = 1;
      player.stats.st_tsbticks = 1;
      player.stats.st_flags = ST_INITIAL;
      for (i = 0; i < 95; i++)
	{
	  player.stats.st_keymap[i] = i + 32;
	}
      if (pfd < 0)
	{
	  /* we can't survive without a player file */
	  fprintf (stderr, "FATAL ERROR: Can't open PLAYERFILE in resettourn().\n");
	  fflush (stderr);
	  freemem (0, 0, NULL);
	}
      else
	{
	  fstat (pfd, &buf);
	  entries = buf.st_size / sizeof (struct statentry);
	  lseek (pfd, entries * sizeof (struct statentry), 0);
	  write (pfd, (char *) &player, sizeof (struct statentry));
	  j->p_pos = entries;
	}
    }
  close (pfd);
}


obliterate (wflag, kreason)
     int wflag;
     char kreason;
{
/* 0 = do nothing to war status, 1= make war with all, 2= make peace with all */
  struct player *j;
  int h, i, k;

  /* clear torps and plasmas out */
  bzero (torps, sizeof (struct torp) * MAXPLAYER * MAXTORP);
  bzero (plasmatorps, sizeof (struct plasmatorp) * MAXPLAYER * MAXPLASMA);
  for (h = 0, j = &players[0]; h < MAXPLAYER; h++, j++)
    {
      if (j->p_status == PFREE)
	continue;
      j->p_status = PEXPLODE;
      j->p_whydead = kreason;
      if (j->p_ship.s_type == STARBASE)
	j->p_explode = 2 * SBEXPVIEWS / PLAYERFUSE;
      else
	j->p_explode = 10 / PLAYERFUSE;
      j->p_ntorp = 0;
      j->p_nplasmatorp = 0;
      if (wflag == 1)
	j->p_hostile = (FED | ROM | ORI | KLI);		/* angry */
      else if (wflag == 2)
	j->p_hostile = 0;	/* otherwise make all peaceful */
      if (j->p_armies > 0)
	{
	  k = 10 * (remap[j->p_team] - 1);
	  if (k >= 0 && k <= 30)
	    {
	      for (i = 0; i < 10; i++)
		{
		  if (planets[i + k].pl_owner == j->p_team)
		    {
		      planets[i + k].pl_armies += j->p_armies;
		      /* dont hose tarmscar stat */
		      if (status->tourn)
			{
			  if (j->p_ship.s_type == STARBASE)
			    {
			      j->p_stats.st_tsbarmscar -= j->p_armies;
			    }
			  else
			    {
			      j->p_stats.st_tarmscar -= j->p_armies;
			    }
			  j->p_armies = 0;	/* make sure we don't dble credit */
			}
		      break;
		    }
		}
	    }
	}
    }
}

udplayers ()
{
  register int i, k;
  register struct player *j;
  float dist;			/* used by tractor beams */
  int maxspeed;
  static int cnt = 1;
  long pl_tmp;
  long team_offense[NUMTEAM + 1];
  long pl_toffdelta;
  team_offense[remap[FED]] = team_offense[remap[ROM]] = 1;
  team_offense[remap[KLI]] = team_offense[remap[ORI]] = 1;

  nplayers = 0;
  tcount[FED] = tcount[ROM] = tcount[KLI] = tcount[ORI] = 0;
  TimeoutStatus = 0;
  pdistmin = MAXFLOAT;	/* some really large number */
  cnt++;
  for (i = status->active = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      switch (j->p_status)
	{
	case POUTFIT:
	  if (++(j->p_ghostbuster) > OUTFITTIME)
	    {
	      saveplayer (j);
	      j->p_status = PFREE;
	      j->p_ghostbuster = 0;	/* stop from hosing new players */
#ifdef DS
	      if (j->p_process > 1)	/* too risky not to */
		(void) kill (j->p_process, SIGTERM);
#endif
	    }
	  continue;
	case PFREE:
	  nplayers++;		/* XXX what??? */
	  j->p_ghostbuster = 0;	/* stop from hosing new players */
	  continue;
	case POBSERV:
	  /* observer players, perpetually 'dead'-like state */
	  /* think of them as ghosts! */
	  /* but they still might get ghostbusted - attempt to handle that */
	  if (++(j->p_ghostbuster) > GHOSTTIME)
	    {
	      j->p_status = PDEAD;
	      j->p_armies = 0;	/* hack- if you are locked on a player who 
				   carries then that players armies will get saved
				   but they are actually double credited sort of */
	      ghostmess (j);
	      saveplayer (j);
	      j->p_whydead = KGHOST;
	      j->p_whodead = i;
	      break;
	    }
	  continue;
	case PDEAD:
	  if (--j->p_explode <= 0)
	    {			/* Ghost Buster */
	      saveplayer (j);
	      j->p_status = POUTFIT;	/* change 5/24/91 TC, was PFREE */
	    }
	  continue;
	case PEXPLODE:
	  j->p_updates++;
	  j->p_flags &= ~PFCLOAK;
	  if ((j->p_ship.s_type == STARBASE) &&
	      (j->p_explode == ((2 * SBEXPVIEWS - 3) / PLAYERFUSE)))
	    blowup (j);		/* damdiffe everyone else around */
	  else if (j->p_explode == ((10 - 3) / PLAYERFUSE))
	    blowup (j);		/* damdiffe everyone else around */

	  if (--j->p_explode <= 0)
	    {
	      j->p_status = PDEAD;
	      j->p_explode = 600 / PLAYERFUSE;	/* set ghost buster */
	    }

	  /* At this point, docked ships become removed. */
	  if (j->p_flags & PFDOCK)
	    {
	      players[j->p_docked].p_docked--;
	      players[j->p_docked].p_port[j->p_port[0]] = VACANT;
	      j->p_flags &= ~PFDOCK;
	    }
	  if (j->p_ship.s_type == STARBASE)
	    {
	      if ((j->p_whydead == KSHIP) ||
		  (j->p_whydead == KTORP) ||
		  (j->p_whydead == KPHASER) ||
		  (j->p_whydead == KPLASMA) ||
		  (j->p_whydead == KPLANET) ||
		  (j->p_whydead == KGENOCIDE))
		teams[j->p_team].s_turns = SBREBUILDTIME;
	      /* 30 minute reconstruction period for new starbase */
	      /* IckyBug... used to be 30, which made it a 20 
	         ** minute period */
	      /* was 45, but then, it was being 'ticked' in
	         ** udplanets, 1/40 sec. I moved to its own 1/min
	         ** udteams() routine */
	      for (k = 0; k < NUMPORTS; k++)
		if (j->p_port[k] != VACANT)
		  {
		    players[j->p_port[k]].p_flags &= ~PFDOCK;
		    j->p_port[k] = VACANT;
		  }
	      j->p_docked = 0;
	    }
	  /* And he is ejected from orbit. */
	  if (j->p_flags & PFORBIT)
	    j->p_flags &= ~PFORBIT;

	  /* Fall through to alive so explosions move */

	case PALIVE:
	  /* Move Player in orbit */
	  if (nstats)
	    {
	      nstats->team[remap[j->p_team]].player.num += 1;
	      /* Yeah, going wild ... */
	      if (j->p_fuel * 100 / j->p_ship.s_maxfuel < 15)
		nstats->team[remap[j->p_team]].player.lowfuel += 1;
	      if (j->p_damage * 100 / j->p_ship.s_maxdamage > 50)
		nstats->team[remap[j->p_team]].player.damaged += 1;
	    }
	  if ((j->p_flags & PFORBIT) && !(j->p_flags & PFDOCK))
	    {
	      j->p_dir += 2;
	      j->p_desdir = j->p_dir;
	      j->p_x = planets[j->p_planet].pl_x + ORBDIST
		* Cos[(unsigned char) (j->p_dir - (unsigned char) 64)];
	      j->p_y = planets[j->p_planet].pl_y + ORBDIST
		* Sin[(unsigned char) (j->p_dir - (unsigned char) 64)];
	    }

	  /* Move player through space */
	  else if (!(j->p_flags & PFDOCK))
	    {

	      if ((j->p_dir != j->p_desdir) && (j->p_status != PEXPLODE))
		changedir (j);

	      /* Alter speed */
	      maxspeed = (j->p_ship.s_maxspeed + 2) -
		(j->p_ship.s_maxspeed + 1) *
		((float) j->p_damage / (float) (j->p_ship.s_maxdamage));
	      if (j->p_desspeed > maxspeed)
		j->p_desspeed = maxspeed;
	      if (j->p_flags & PFENG)
		j->p_desspeed = 1;

	      /* Charge for speed */
	      if (j->p_fuel < (j->p_ship.s_warpcost * j->p_speed))
		{
		  /* 
		     * Out of fuel ... set speed to one that uses less fuel
		     *  than the ship's reactor generates (if necessary).
		   */
		  if (j->p_ship.s_recharge / j->p_ship.s_warpcost <
		      j->p_speed)
		    {
		      j->p_desspeed = j->p_ship.s_recharge / j->p_ship.s_warpcost + 2;
		      /* Above incantation is a magic formula ... (hack). */
		      if (j->p_desspeed > j->p_ship.s_maxspeed)
			j->p_desspeed = j->p_ship.s_maxspeed - 1;
		    }
		  else
		    {
		      j->p_desspeed = j->p_speed;
		    }
		  j->p_fuel = 0;
		}
	      else
		{
		  j->p_fuel -= (j->p_ship.s_warpcost * j->p_speed);
		  j->p_etemp += j->p_speed;

		  /* Charge SB's for mass of docked vessels ... */
		  if (j->p_ship.s_type == STARBASE)
		    {
		      for (k = 0; k < NUMPORTS; k++)
			if (j->p_port[k] != VACANT)
			  {
			    j->p_fuel -= players[j->p_port[k]].p_ship.s_warpcost * j->p_speed;
			    j->p_etemp += .7 * (j->p_speed * j->p_docked);
			  }
		    }
		}

	      if (j->p_desspeed > j->p_speed)
		{
		  j->p_subspeed += j->p_ship.s_accint;
		}
	      if (j->p_desspeed < j->p_speed)
		j->p_subspeed -= j->p_ship.s_decint;

	      if (j->p_subspeed / 1000)
		{
		  j->p_speed += j->p_subspeed / 1000;
		  j->p_subspeed %= 1000;
		  if (j->p_speed < 0)
		    j->p_speed = 0;
		  if (j->p_speed > j->p_ship.s_maxspeed)
		    j->p_speed = j->p_ship.s_maxspeed;
		}
	      j->p_x += (double) j->p_speed * Cos[j->p_dir] * WARP1;
	      j->p_y += (double) j->p_speed * Sin[j->p_dir] * WARP1;

	      /* Bounce off the side of the galaxy */
	      if (j->p_x < 0)
		{
		  j->p_x = -j->p_x;
		  if (j->p_dir == 192)
		    j->p_dir = j->p_desdir = 64;
		  else
		    j->p_dir = j->p_desdir = 64 - (j->p_dir - 192);
		}
	      else if (j->p_x > GWIDTH)
		{
		  j->p_x = GWIDTH - (j->p_x - GWIDTH);
		  if (j->p_dir == 64)
		    j->p_dir = j->p_desdir = 192;
		  else
		    j->p_dir = j->p_desdir = 192 - (j->p_dir - 64);
		}
	      if (j->p_y < 0)
		{
		  j->p_y = -j->p_y;
		  if (j->p_dir == 0)
		    j->p_dir = j->p_desdir = 128;
		  else
		    j->p_dir = j->p_desdir = 128 - j->p_dir;
		}
	      else if (j->p_y > GWIDTH)
		{
		  j->p_y = GWIDTH - (j->p_y - GWIDTH);
		  if (j->p_dir == 128)
		    j->p_dir = j->p_desdir = 0;
		  else
		    j->p_dir = j->p_desdir = 0 - (j->p_dir - 128);
		}
	      /* do confinereq processing */
	      /* we _could_ do bouncing here... but nah.... - jmn */
	      if ((confinereq[0] || confinereq[1]) && !status->tourn)
		{
		  if (j->p_x < cbounds[j->p_team][0])
		    j->p_x = cbounds[j->p_team][0];
		  if (j->p_y < cbounds[j->p_team][1])
		    j->p_y = cbounds[j->p_team][1];
		  if (j->p_x > cbounds[j->p_team][2])
		    j->p_x = cbounds[j->p_team][2];
		  if (j->p_y > cbounds[j->p_team][3])
		    j->p_y = cbounds[j->p_team][3];
		}
	    }

	  /* If player is actually dead, don't do anything below ... */
	  if (j->p_status == PEXPLODE || j->p_status == PDEAD ||
	      j->p_status == POBSERV)
	    break;

	  if (j->p_ship.s_type == STARBASE)
	    {
	      /* kludge to give credit for being base and nothing else in tmode */
	      if (status->tourn && j->p_stats.st_tticks == 0)
		j->p_stats.st_tticks = 1;
	      if (status->tourn)
		j->p_stats.st_tsbticks++;
	      else
		j->p_stats.st_sbticks++;
	    }
	  else if (status->tourn)
	    {
	      j->p_stats.st_tticks++;
	      status->timeprod++;
	    }
	  else
	    {
	      j->p_stats.st_ticks++;
	    }

	  if (++(j->p_ghostbuster) > GHOSTTIME)
	    {
	      j->p_status = PEXPLODE;
	      if (j->p_ship.s_type == STARBASE)
		j->p_explode = 2 * SBEXPVIEWS / PLAYERFUSE;
	      else
		j->p_explode = 10 / PLAYERFUSE;
	      ghostmess (j);
	      saveplayer (j);
	      j->p_whydead = KGHOST;
	      j->p_whodead = i;
	    }

	  status->active += (1 << i);
	  tcount[j->p_team]++;
	  j->p_updates++;

	  /* Charge for shields */
	  if (j->p_flags & PFSHIELD)
	    {			/* This is a kludge, I know. */
	      switch (j->p_ship.s_type)
		{
		case SCOUT:
		  j->p_fuel -= 2;
		  break;
		case DESTROYER:
		case CRUISER:
		case BATTLESHIP:
		case ASSAULT:
		  j->p_fuel -= 3;
		  break;
		case STARBASE:
		  j->p_fuel -= 6;
		  break;
		default:
		  break;
		}
	    }

	  /* affect tractor beams */
	  if (j->p_flags & PFTRACT)
	    {
	      if ((isAlive (&players[j->p_tractor])) &&
		  ((j->p_fuel > TRACTCOST) && !(j->p_flags & PFENG)) &&
	      ((dist = hypot ((double) (j->p_x - players[j->p_tractor].p_x),
			      (double) (j->p_y - players[j->p_tractor].p_y)))
	       < ((double) TRACTDIST) * j->p_ship.s_tractrng) &&
		  (!(j->p_flags & (PFORBIT | PFDOCK))) &&
		  (!(players[j->p_tractor].p_flags & PFDOCK)))
		{
		  float cosTheta, sinTheta;	/* Cos and Sin from me to him */
		  int halfforce;	/* Half force of tractor */
		  int dir;	/* -1 for repress, otherwise 1 */

		  if (players[j->p_tractor].p_flags & PFORBIT)
		    players[j->p_tractor].p_flags &= ~PFORBIT;

		  j->p_fuel -= TRACTCOST;
		  j->p_etemp += TRACTEHEAT;

		  cosTheta = players[j->p_tractor].p_x - j->p_x;
		  sinTheta = players[j->p_tractor].p_y - j->p_y;
		  if (dist == 0)
		    dist = 1;	/* prevent divide by zero */
		  cosTheta /= dist;	/* normalize sin and cos */
		  sinTheta /= dist;
		  /* force of tractor is WARP2 * tractstr */
		  halfforce = (WARP1 * j->p_ship.s_tractstr);

		  dir = 1;
		  if (j->p_flags & PFPRESS)
		    dir = -1;
		  /* change in position is tractor strength over mass */
		  j->p_x += dir * cosTheta * halfforce / (j->p_ship.s_mass);
		  j->p_y += dir * sinTheta * halfforce / (j->p_ship.s_mass);
		  players[j->p_tractor].p_x -= dir * cosTheta *
		    halfforce / (players[j->p_tractor].p_ship.s_mass);
		  players[j->p_tractor].p_y -= dir * sinTheta *
		    halfforce / (players[j->p_tractor].p_ship.s_mass);
		}
	      else
		{
		  j->p_flags &= ~(PFTRACT | PFPRESS);
		}
	    }

	  /* cool weapons */
	  j->p_wtemp -= j->p_ship.s_wpncoolrate;
	  if (j->p_wtemp < 0)
	    j->p_wtemp = 0;
	  if (j->p_flags & PFWEP)
	    {
	      if (--j->p_wtime <= 0)
		j->p_flags &= ~PFWEP;
	    }
	  else if (j->p_wtemp > j->p_ship.s_maxwpntemp)
	    {
	      if (!(rrandom () % 40))
		{
		  j->p_flags |= PFWEP;
		  j->p_wtime = ((rrandom () % 150) + 100) / PLAYERFUSE;
		}
	    }
	  /* cool engine */
	  j->p_etemp -= j->p_ship.s_egncoolrate;
	  if (j->p_etemp < 0)
	    j->p_etemp = 0;
	  if (j->p_flags & PFENG)
	    {
	      if (--j->p_etime <= 0)
		j->p_flags &= ~PFENG;
	    }
	  else if (j->p_etemp > j->p_ship.s_maxegntemp)
	    {
	      if (!(rrandom () % 40))
		{
		  j->p_flags |= PFENG;
		  j->p_etime = ((rrandom () % 150) + 100) / PLAYERFUSE;
		  j->p_desspeed = 0;
		}
	    }

	  /* Charge for cloaking */
	  if (j->p_flags & PFCLOAK)
	    {
	      if (j->p_fuel < j->p_ship.s_cloakcost)
		{
		  j->p_flags &= ~PFCLOAK;
		}
	      else
		{
		  j->p_fuel -= j->p_ship.s_cloakcost;
		}
	    }

	  /* Add fuel */
	  if ((j->p_flags & PFORBIT) &&
	      (planets[j->p_planet].pl_flags & PLFUEL) &&
	      (!(planets[j->p_planet].pl_owner
		 & (j->p_swar | j->p_hostile))))
	    {
	      j->p_fuel += 8 * j->p_ship.s_recharge;
	    }
	  else if ((j->p_flags & PFDOCK) && (j->p_fuel < j->p_ship.s_maxfuel))
	    {
	      if (players[j->p_docked].p_fuel > SBFUELMIN)
		{
		  j->p_fuel += 12 * j->p_ship.s_recharge;
		  players[j->p_docked].p_fuel -= 12 * j->p_ship.s_recharge;
		}
	    }
	  else
	    j->p_fuel += 2 * j->p_ship.s_recharge;

	  if (j->p_fuel > j->p_ship.s_maxfuel)
	    j->p_fuel = j->p_ship.s_maxfuel;
	  if (j->p_fuel < 0)
	    {
	      j->p_desspeed = 0;
	      j->p_flags &= ~PFCLOAK;
	    }

	  /* repair shields */
	  if (j->p_shield < j->p_ship.s_maxshield)
	    {
	      if ((j->p_flags & PFREPAIR) && (j->p_speed == 0))
		{
		  j->p_subshield += j->p_ship.s_repair * 4;
		  if ((j->p_flags & PFORBIT) &&
		      (planets[j->p_planet].pl_flags & PLREPAIR) &&
		      (!(planets[j->p_planet].pl_owner
			 & (j->p_swar | j->p_hostile))))
		    {
		      j->p_subshield += j->p_ship.s_repair * 4;
		    }
		  if (j->p_flags & PFDOCK)
		    j->p_subshield += 6 * j->p_ship.s_repair;
		}
	      else
		j->p_subshield += j->p_ship.s_repair * 2;
	      if (j->p_subshield / 1000)
		{
		  j->p_shield += j->p_subshield / 1000;
		  j->p_subshield %= 1000;
		}
	      if (j->p_shield > j->p_ship.s_maxshield)
		{
		  j->p_shield = j->p_ship.s_maxshield;
		  j->p_subshield = 0;
		}
	    }

	  /* repair damage */
	  if (j->p_damage && !(j->p_flags & PFSHIELD))
	    {
	      if ((j->p_flags & PFREPAIR) && (j->p_speed == 0))
		{
		  j->p_subdamage += j->p_ship.s_repair * 2;
		  if ((j->p_flags & PFORBIT) &&
		      (planets[j->p_planet].pl_flags & PLREPAIR) &&
		      (!(planets[j->p_planet].pl_owner
			 & (j->p_swar | j->p_hostile))))
		    {
		      j->p_subdamage += j->p_ship.s_repair * 2;
		    }
		  if (j->p_flags & PFDOCK)
		    j->p_subdamage += j->p_ship.s_repair * 3;
		}
	      else
		j->p_subdamage += j->p_ship.s_repair;
	      if (j->p_subdamage / 1000)
		{
		  j->p_damage -= j->p_subdamage / 1000;
		  j->p_subdamage %= 1000;
		}
	      if (j->p_damage < 0)
		{
		  j->p_damage = 0;
		  j->p_subdamage = 0;
		}
	    }

	  /* Move Player in dock */
	  if (j->p_flags & PFDOCK)
	    {
	      j->p_x = players[j->p_docked].p_x + DOCKDIST * Cos[(j->p_port[0] * 90 + 45) * 255 / 360];
	      j->p_y = players[j->p_docked].p_y + DOCKDIST * Sin[(j->p_port[0] * 90 + 45) * 255 / 360];
	    }

	  /* we'll need this for figuring the true_offense */
	  pl_tmp = (j->p_team == INLteams[0]) ? INLteams[1] : INLteams[0];
	  pl_tmp = 10 * (remap[pl_tmp] - 1);
	  pl_toffdelta = (long) sqrt ((((double) j->p_x - planets[pl_tmp].pl_x) *
				      (j->p_x - planets[pl_tmp].pl_x) +
				  ((double) j->p_y - planets[pl_tmp].pl_y) *
				      (j->p_y - planets[pl_tmp].pl_y)));
	  j->p_disthw = pl_toffdelta;
	  team_offense[remap[j->p_team]] += pl_toffdelta;
	  if (debug && ((cnt % 100) == 0))
	    {
	      printf ("p_no=%d, disthw=%d, toff[%d(%s)]=%d\n",
		      j->p_no, j->p_disthw, remap[j->p_team],
		      teamshort[j->p_team], team_offense[remap[j->p_team]]);
	    }

	  /* Set player's alert status */
#define YRANGE ((GWIDTH)/7)
#define RRANGE ((GWIDTH)/10)
	  j->p_flags |= PFGREEN;
	  j->p_flags &= ~(PFRED | PFYELLOW);
	  for (k = 0; k < MAXPLAYER; k++)
	    {
	      int dx, dy, dist;
	      if ((players[k].p_status != PALIVE) ||
		  ((!((j->p_swar | j->p_hostile) & players[k].p_team)) &&
		   (!((players[k].p_swar | players[k].p_hostile) &
		      j->p_team))))
		{
		  continue;
		}
	      else if (j == &players[k])
		{
		  continue;
		}
	      else
		{
		  dx = j->p_x - players[k].p_x;
		  dy = j->p_y - players[k].p_y;
		  if (ABS (dx) > YRANGE || ABS (dy) > YRANGE)
		    continue;
		  dist = dx * dx + dy * dy;
		  if (dist < pdistmin)
		    pdistmin = dist;	/* jmn */
		  if (dist < RRANGE * RRANGE)
		    {
		      j->p_flags |= PFRED;
		      j->p_flags &= ~(PFGREEN | PFYELLOW);
		      TimeoutStatus++;	/* Remember for timeout -- BM */
		    }
		  else if ((dist < YRANGE * YRANGE) &&
			   (!(j->p_flags & PFRED)))
		    {
		      j->p_flags |= PFYELLOW;
		      j->p_flags &= ~(PFGREEN | PFRED);
		      TimeoutStatus++;	/* Remember for timeout -- BM */
		    }
		}
	    }
	  break;
	}			/* end switch */
    }

  /* update true offense stat - jmn */
  if (status->tourn)
    {
      for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
	{
	  if (j->p_status == PALIVE)
	    {
	      if (j->p_ship.s_type != STARBASE)
		j->p_stats.st_toffense +=
		  j->p_disthw * 100 * tcount[j->p_team] / team_offense[remap[j->p_team]];
	      else{
		j->p_stats.st_tsbtoffense +=
		  j->p_disthw * 100 * tcount[j->p_team] / team_offense[remap[j->p_team]];
	      }
	    }
	}
    }

  if (nplayers == MAXPLAYER)
    {
      if (dietime == -1)
	dietime = ticks + 200 / PLAYERFUSE;
      /* bav - 60 second timeout now 20 */
    }
  else
    {
      /* no more dieing due to end of INL game - jn */
      /*if (INL_die_complete == 0) */ dietime = -1;
      /* bav - Reset only if tourney not ended */
    }
}

changedir (sp)
     struct player *sp;
{
  unsigned int ticks;
  unsigned int min, max;
  int speed;

/* Change 1/20/91 TC new-style turn rates */

  speed = sp->p_speed;
  if (speed == 0)
    {
      sp->p_dir = sp->p_desdir;
      sp->p_subdir = 0;
    }
  else
    {
      if (newturn)
	sp->p_subdir += sp->p_ship.s_turns / (speed * speed);
      else
	sp->p_subdir += sp->p_ship.s_turns / ((sp->p_speed < 30) ? (1 << sp->p_speed) : 1000000000);

      ticks = sp->p_subdir / 1000;
      if (ticks)
	{
	  if (sp->p_dir > sp->p_desdir)
	    {
	      min = sp->p_desdir;
	      max = sp->p_dir;
	    }
	  else
	    {
	      min = sp->p_dir;
	      max = sp->p_desdir;
	    }
	  if ((ticks > max - min) || (ticks > 256 - max + min))
	    sp->p_dir = sp->p_desdir;
	  else if ((unsigned char) ((int) sp->p_dir - (int) sp->p_desdir) > 127)
	    sp->p_dir += ticks;
	  else
	    sp->p_dir -= ticks;
	  sp->p_subdir %= 1000;
	}
    }
}


udcloak ()
{
  register int i;

  for (i = 0; i < MAXPLAYER; i++)
    {
      if (isAlive (&players[i]))
	if ((players[i].p_flags & PFCLOAK) &&
	    (players[i].p_cloakphase < (CLOAK_PHASES - 1)))
	  {
	    players[i].p_cloakphase++;
	  }
	else if (!(players[i].p_flags & PFCLOAK) &&
		 (players[i].p_cloakphase > 0))
	  {
	    players[i].p_cloakphase--;
	  }
    }
}



udtorps ()
{
  register int i, turn = 0, heading = 0;
  register struct torp *j;

  for (i = 0, j = &torps[i]; i < MAXPLAYER * MAXTORP; i++, j++)
    {
      switch (j->t_status)
	{
	case TFREE:
	  continue;
	case TMOVE:
	case TSTRAIGHT:
	  if (j->t_turns > 0)
	    {
	      turn = torp_track_target (j);
	      if (turn < 0)
		{
		  heading = ((int) j->t_dir) - j->t_turns;
		  j->t_dir = ((heading < 0) ? ((unsigned char) (256 + heading)) :
			      ((unsigned char) heading));
		}
	      else if (turn > 0)
		{
		  heading = ((int) j->t_dir) + j->t_turns;
		  j->t_dir = ((heading > 255) ? ((unsigned char) (heading - 256)) :
			      ((unsigned char) heading));
		}
	    }

	  j->t_x += (double) j->t_speed * Cos[j->t_dir] * WARP1;
	  if (j->t_x < 0)
	    {
	      j->t_x = 0;
	      j->t_status = TDET;	/* no wall kills 8/31/91 TC */
	      j->t_whodet = j->t_owner;		/* 8/31/91 TC */
	      explode (j);
	      break;
	    }
	  else if (j->t_x > GWIDTH)
	    {
	      j->t_x = GWIDTH;
	      j->t_status = TDET;	/* no wall kills 8/31/91 TC */
	      j->t_whodet = j->t_owner;		/* 8/31/91 TC */
	      explode (j);
	      break;
	    }
	  j->t_y += (double) j->t_speed * Sin[j->t_dir] * WARP1;
	  if (j->t_y < 0)
	    {
	      j->t_y = 0;
	      j->t_status = TDET;	/* no wall kills 8/31/91 TC */
	      j->t_whodet = j->t_owner;		/* 8/31/91 TC */
	      explode (j);
	      break;
	    }
	  else if (j->t_y > GWIDTH)
	    {
	      j->t_y = GWIDTH;
	      j->t_status = TDET;	/* no wall kills 8/31/91 TC */
	      j->t_whodet = j->t_owner;		/* 8/31/91 TC */
	      explode (j);
	      break;
	    }

	  /* Make sure that player torps wobble */
	  if (j->t_status == TMOVE)
	    j->t_dir += (rrandom () % 3) - 1;

	  if (j->t_fuse-- <= 0)
	    {
	      j->t_status = TFREE;
	      players[j->t_owner].p_ntorp--;
	    }
	  else if (near (j))
	    {
	      explode (j);
	    }
	  break;
	case TDET:
	  explode (j);
	  break;
	case TEXPLODE:
	  if (j->t_fuse-- <= 0)
	    {
	      j->t_status = TFREE;
	      players[j->t_owner].p_ntorp--;
	    }
	  break;
	case TOFF:
	  j->t_status = TFREE;
	  players[j->t_owner].p_ntorp--;
	  break;
	default:		/* Shouldn't happen */
	  j->t_status = TFREE;
	  break;
	}
    }
}


udplasmatorps ()
{
  register int i, turn = 0, heading;
  register struct plasmatorp *j;

  for (i = 0, j = &plasmatorps[i]; i < MAXPLAYER * MAXPLASMA; i++, j++)
    {
      switch (j->pt_status)
	{
	case PTFREE:
	  continue;
	case PTMOVE:
	  turn = plasma_track_target (j);
	  if (turn < 0)
	    {
	      heading = ((int) j->pt_dir) - j->pt_turns;
	      j->pt_dir = ((heading < 0) ? ((unsigned char) (256 + heading)) :
			   ((unsigned char) heading));
	    }
	  else if (turn > 0)
	    {
	      heading = ((int) j->pt_dir) + j->pt_turns;
	      j->pt_dir = ((heading > 255) ? ((unsigned char) (heading - 256)) :
			   ((unsigned char) heading));
	    }

	  j->pt_x += (double) j->pt_speed * Cos[j->pt_dir] * WARP1;
	  if (j->pt_x < 0)
	    {
	      j->pt_x = 0;
	      pexplode (j);
	      break;
	    }
	  else if (j->pt_x > GWIDTH)
	    {
	      j->pt_x = GWIDTH;
	      pexplode (j);
	      break;
	    }
	  j->pt_y += (double) j->pt_speed * Sin[j->pt_dir] * WARP1;
	  if (j->pt_y < 0)
	    {
	      j->pt_y = 0;
	      pexplode (j);
	      break;
	    }
	  else if (j->pt_y > GWIDTH)
	    {
	      j->pt_y = GWIDTH;
	      pexplode (j);
	      break;
	    }

	  if (j->pt_fuse-- <= 0)
	    {
	      j->pt_status = PTFREE;
	      players[j->pt_owner].p_nplasmatorp--;
	    }
	  else if (pnear (j))
	    {
	      pexplode (j);
	    }
	  break;
	case PTDET:
	  pexplode (j);
	  break;
	case PTEXPLODE:
	  if (j->pt_fuse-- <= 0)
	    {
	      j->pt_status = PTFREE;
	      players[j->pt_owner].p_nplasmatorp--;
	    }
	  break;
	default:		/* Shouldn't happen */
	  j->pt_status = PTFREE;
	  break;
	}
    }
}


/* See if there is someone close enough to explode for */
near (torp)
     struct torp *torp;
{
  register int i, expdist = EXPDIST;
  int dx, dy;
  register struct player *j;

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (!(j->p_status == PALIVE))
	continue;
      if (torp->t_owner == j->p_no)
	continue;
      /* This is tricky.  If you aren't at war with the team,
         and that team is not at war with your team, continue.
       */
      if ((!(torp->t_war & j->p_team)) &&
	  (!(torp->t_team & (j->p_swar | j->p_hostile))))
	continue;
      dx = torp->t_x - j->p_x;
      dy = torp->t_y - j->p_y;
      if (ABS (dx) > expdist || ABS (dy) > expdist)
	continue;
      if (dx * dx + dy * dy < expdist * expdist)
	return 1;
    }
  return 0;
}


/* See if there is someone close enough to explode for */
pnear (plasmatorp)
     struct plasmatorp *plasmatorp;
{
  register int i, expdist = EXPDIST;
  int dx, dy;
  register struct player *j;

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (!(j->p_status == PALIVE))
	continue;
      if (plasmatorp->pt_owner == j->p_no)
	continue;
      /* This is tricky.  If you aren't at war with the team,
         and that team is not at war with your team, continue.
       */
      if ((!(plasmatorp->pt_war & j->p_team)) &&
	  (!(plasmatorp->pt_team & (j->p_swar | j->p_hostile))))
	continue;
      dx = plasmatorp->pt_x - j->p_x;
      dy = plasmatorp->pt_y - j->p_y;
      if (ABS (dx) > expdist || ABS (dy) > expdist)
	continue;
      if (dx * dx + dy * dy < (expdist) * (expdist))
	return 1;
    }
  return 0;
}



/* Do damage to all surrounding players */

explode (torp)
     struct torp *torp;
{
  register int i;
  int dx, dy, dist;
  int damage;
  register struct player *j;
  register struct player *k;

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (!(j->p_status == PALIVE))
	continue;
      if (torp->t_owner == j->p_no)	/* This isn't realistic */
	continue;
      /* Now, only the person who detonated the torpedo and people
         * on one of the other teams takes damage.
         * This prevents hosers from killing teammates with the 'd' key 
       */
      if (torp->t_status == TDET &&
	  torp->t_whodet != NODET &&	/* shouldn't happen but has -- tsh */
	  j->p_no != torp->t_whodet &&
	  torp->t_whodet < MAXPLAYER &&
	  j->p_team == players[torp->t_whodet].p_team)
	{
	  continue;
	}
      dx = torp->t_x - j->p_x;
      dy = torp->t_y - j->p_y;
      if (ABS (dx) > DAMDIST || ABS (dy) > DAMDIST)	/*XXX */
	continue;
      dist = dx * dx + dy * dy;
      if (dist > DAMDIST * DAMDIST)
	continue;
      if (dist > EXPDIST * EXPDIST)
	{
	  damage = torp->t_damage * (DAMDIST - sqrt ((double) dist)) /
	    (DAMDIST - EXPDIST);
	}
      else
	{
	  damage = torp->t_damage;
	}
      if (damage > 0)
	{
	  /* First, check to see if torp owner has started a war */
	  if (players[torp->t_owner].p_hostile & j->p_team)
	    {
	      players[torp->t_owner].p_swar |= j->p_team;
	    }
	  /* Note that if a player is at peace with the victim, then
	     the torp has caused damage either accidently, or because
	     the victim was at war with, or hostile to, the player.
	     In either case, we don't consider the damage to be
	     an act of war */

	  if (j->p_flags & PFSHIELD)
	    {
	      j->p_shield -= damage;
	      if (j->p_shield < 0)
		{
		  j->p_damage -= j->p_shield;
		  j->p_shield = 0;
		}
	    }
	  else
	    {
	      j->p_damage += damage;
	    }
	  if (j->p_damage >= j->p_ship.s_maxdamage)
	    {
	      j->p_status = PEXPLODE;
	      if (j->p_ship.s_type == STARBASE)
		{
		  j->p_explode = 2 * SBEXPVIEWS / PLAYERFUSE;
		}
	      else
		{
		  j->p_explode = 10 / PLAYERFUSE;
		}
	      k = ((torp->t_whodet != NODET)
		   && (torp->t_whodet != j->p_no)
		   && (players[torp->t_whodet].p_team != j->p_team)) ?
		&players[torp->t_whodet] : &players[torp->t_owner];
	      if ((k->p_team != j->p_team) ||
		  ((k->p_team == j->p_team) && (j->p_flags & PFPRACTR)))
		{
		  k->p_kills += 1.0 +
		    j->p_armies * 0.1 + j->p_kills * 0.1;
		  checkmaxkills (k->p_no);
		}
	      /* moved outside if - jmn */
	      killerstats ( /* credit kill */ k->p_no,
	      /* real killer */ torp->t_owner, j);

	      loserstats (i);
	      j->p_whydead = KTORP;
	      j->p_whodead = k->p_no;
	      killmess (j, /* credit kill */ k,
	      /* real killer */ &players[torp->t_owner],
			(k->p_no != torp->t_owner) ? KTORP2 : KTORP);
	    }
	}
    }
  torp->t_status = TEXPLODE;
  torp->t_fuse = 10 / TORPFUSE;
}

/* Do damage to all surrounding players */

pexplode (plasmatorp)
     struct plasmatorp *plasmatorp;
{
  register int i;
  int dx, dy, dist;
  int damage;
  register struct player *j;

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (!(j->p_status == PALIVE))
	continue;

      /* Testing to see if this helps make them risky ... (Scott: 12/10/88)
         if (plasmatorp->pt_owner == j->p_no) / This isn't realistic /
         continue;
       */

      dx = plasmatorp->pt_x - j->p_x;
      dy = plasmatorp->pt_y - j->p_y;
      if (ABS (dx) > PLASDAMDIST || ABS (dy) > PLASDAMDIST)	/*XXX */
	continue;
      dist = dx * dx + dy * dy;
      if (dist > PLASDAMDIST * PLASDAMDIST)
	continue;
      if (dist > (EXPDIST) * (EXPDIST))
	{
	  damage = plasmatorp->pt_damage * (PLASDAMDIST - sqrt ((double) dist)) /
	    (PLASDAMDIST - (EXPDIST));
	}
      else
	{
	  damage = plasmatorp->pt_damage;
	}
      if (damage > 0)
	{
	  /* First, check to see if torp owner has started a war */
	  if (players[plasmatorp->pt_owner].p_hostile & j->p_team)
	    {
	      players[plasmatorp->pt_owner].p_swar |= j->p_team;
	    }
	  /* Note that if a player is at peace with the victim, then
	     the torp has caused damage either accidently, or because
	     the victim was at war with, or hostile to, the player.
	     In either case, we don't consider the damage to be
	     an act of war */

	  if (j->p_flags & PFSHIELD)
	    {
	      j->p_shield -= damage;
	      if (j->p_shield < 0)
		{
		  j->p_damage -= j->p_shield;
		  j->p_shield = 0;
		}
	    }
	  else
	    {
	      j->p_damage += damage;
	    }
	  if (j->p_damage >= j->p_ship.s_maxdamage)
	    {
	      j->p_status = PEXPLODE;
	      if (j->p_ship.s_type == STARBASE)
		j->p_explode = 2 * SBEXPVIEWS / PLAYERFUSE;
	      else
		j->p_explode = 10 / PLAYERFUSE;
	      players[plasmatorp->pt_owner].p_kills += 1.0 +
		j->p_armies * 0.1 + j->p_kills * 0.1;
	      /* eventually award to player who detted the torp? */
	      killerstats (plasmatorp->pt_owner, plasmatorp->pt_owner, j);
	      checkmaxkills (plasmatorp->pt_owner);
	      killmess (j, &players[plasmatorp->pt_owner],
			&players[plasmatorp->pt_owner],
			KPLASMA);
	      loserstats (i);
	      j->p_whydead = KPLASMA;
	      j->p_whodead = plasmatorp->pt_owner;
	    }
	}
    }
  plasmatorp->pt_status = PTEXPLODE;
  plasmatorp->pt_fuse = 10 / PLASMAFUSE;
}

loserstats (pl)
     int pl;
{
  char buf[160];
  struct player *dude;
  int teamno;

  dude = &players[pl];
  teamno = remap[dude->p_team];

  if (nstats)
    {
      nstats->team[teamno].deaths += 1;
      if (dude->p_armies)
	nstats->team[teamno].carried += dude->p_armies;
    }
  if (dude->p_ship.s_type == STARBASE)
    {
      if (status->tourn)
	{
	  dude->p_stats.st_tsblosses++;
	  dude->p_stats.st_tsbarmsdied += dude->p_armies;
	}
      else
	dude->p_stats.st_sblosses++;
    }
  else
    {
      if (status->tourn)
	{
	  dude->p_stats.st_tlosses++;
	  dude->p_stats.st_tcarmsdied += dude->p_armies;
	  status->losses++;
	}
      else
	{
	  dude->p_stats.st_losses++;
	}
    }

/* this was here for safety... but it confused ntserv message
   'no more armies to beam down' - removed for now - jmn
   if (status->tourn) {
   dude->p_armies=0;
   }
 */

#ifdef STDBG
  sprintf (buf, "%c%c-> (%s) died ... tac=%d tad=%d cak=%d def=%d",
  teamlet[dude->p_team], shipnos[dude->p_no], shiptypes[dude->p_ship.s_type],
	   dude->p_stats.st_tarmscar,
	   dude->p_stats.st_tarmsdel, dude->p_stats.st_tcarmsdied,
	   dude->p_stats.st_tlosses);
  pmessage (buf, dude->p_no, MINDIV | MDBG, "");
#endif

}

killerstats (cl, pl, victim)
     int cl;
     int pl;
     struct player *victim;
{
  struct player *dude, *credit_killer;
  int i;
#ifdef STDBG
  char buf[160];
#endif

  credit_killer = &players[cl];
  dude = &players[pl];		/* killer */

  /* if R1 explodes killing R2 who kills F3, figure R2 should get the
     credit, not R1 */
  if (credit_killer->p_team == dude->p_team)
    credit_killer = dude;

  if (status->tourn)
    {
      /* we assume here that if credit_killer != dude, dude doesn't
         get st_tkills -tsh */
      if (credit_killer->p_ship.s_type != STARBASE)
	{
	  credit_killer->p_stats.st_tkills++;
	  status->kills++;
	}
      else
	{
	  credit_killer->p_stats.st_tsbkills++;
	}

      status->armsogged += victim->p_armies;
/*      dude->p_stats.st_tarmsbomb += 5 * victim->p_armies;
   this isn't bombing      status->armsbomb += 5 * victim->p_armies;
 */

      if (victim->p_team == dude->p_team)
	{			/* oh oh- blew up teammate */
	  /* does he deserve armsogged credit... I think NOT! */
	  dude->p_stats.st_tfarmsogged += victim->p_armies;
	  if (victim->p_armies > 0)
	    {
	      dude->p_stats.st_tfck++;
	    }
#ifdef STDBG
	  sprintf (buf, "%c%c-> (%s) killed teammate %c%c (%s) fck=%d fao=%d",
		   teamlet[dude->p_team], shipnos[dude->p_no],
		   shiptypes[dude->p_ship.s_type],
		   teamlet[victim->p_team], shipnos[victim->p_no],
		   shiptypes[victim->p_ship.s_type],
		   dude->p_stats.st_tfck, dude->p_stats.st_tfarmsogged);
	  pmessage (buf, dude->p_no, MINDIV | MDBG, "");
#endif
	  if (dude == credit_killer)
	    return;
	  /* otherwise we fall through to award credit_killer with
	     armies ogged -tsh */
	}
      /* if victim->p_team != dude->p_team then dude == credit_killer -tsh */

      credit_killer->p_stats.st_tarmsogged += victim->p_armies;
      /* checks for mutuals by checking time the killer died */
      /* if more than 2 seconds then it can't be a mutual */

      /* skip ahead to victims last kill */
      i = 0;
      while (victim->mykills[i] != NULL && i < 3)
	{
	  /* magic number is 7 seconds to become a pck */
	  if ((ticks - victim->kill_time[i]) > 70)
	    {
	      if (victim->p_ship.s_type != STARBASE && victim->p_ship.s_type != ASSAULT
		  && victim->kills_had[i] >= 0.5)
		credit_killer->p_stats.st_tpck++;
	      if (victim->p_ship.s_type == ASSAULT
		  && victim->kills_had[i] >= 0.333)
		credit_killer->p_stats.st_tpck++;
	      i = 3;		/* finish the loop */
	    }
	  i++;
	}
      /* if i==0 the only kills your victim had were from bombing */
      /* magic number for pck here is 10 seconds */
      if (i == 0 && ticks - victim->whenlastbomb > 100)
	{
	  if (victim->p_ship.s_type != STARBASE && victim->p_ship.s_type != ASSAULT
	      && victim->p_kills >= 0.5)
	    credit_killer->p_stats.st_tpck++;
	  if (victim->p_ship.s_type == ASSAULT
	      && victim->p_kills >= 0.333)
	    credit_killer->p_stats.st_tpck++;
	}
      if (victim->p_armies > 0)
	{
	  credit_killer->p_stats.st_teck++;
	}
      /* acc only counts if other team gave you a kill */
      i = 0;
      while (credit_killer->mykills[i] != NULL && i < 3)
	i++;
      credit_killer->mykills[i] = victim;
      credit_killer->mykills[i + 1] = NULL;
      /* this assumes that killerstats runs after p_kills is updated already */
      credit_killer->kill_given[i] = credit_killer->p_kills;
      credit_killer->kills_had[i] = credit_killer->p_kills -
	(1.0 + victim->p_armies * 0.1 + victim->p_kills * 0.1);
      credit_killer->kill_time[i] = ticks;
#ifdef STDBG
      /* killers info */
      if (credit_killer->mykills[i] == NULL)
	{
	  sprintf (buf, "%c%c-> error: mykills [%d] is NULL",
	   teamlet[credit_killer->p_team], shipnos[credit_killer->p_no], i);
	}
      else
	{
	  sprintf (buf, "%c%c->mk[%d]=%c%c, gv=%0.2f, hd=%0.2f, pck=%d eck=%d cao=%d fck=%d fao=%d",
	       teamlet[credit_killer->p_team], shipnos[credit_killer->p_no],
		   i, teamlet[credit_killer->mykills[i]->p_team], shipnos[credit_killer->mykills[i]->p_no],
		   credit_killer->kill_given[i], credit_killer->kills_had[i], credit_killer->p_stats.st_tpck,
		   credit_killer->p_stats.st_teck, credit_killer->p_stats.st_tarmsogged,
		   credit_killer->p_stats.st_tfck, credit_killer->p_stats.st_tfarmsogged);
	}
      pmessage (buf, credit_killer->p_no, MINDIV | MDBG, "");
#endif
    }
  else
    {				/* !tournament */
      if (dude->p_ship.s_type != STARBASE)
	{
	  dude->p_stats.st_kills++;
	}
      else
	{
	  dude->p_stats.st_sbkills++;
	}
      status->armsogged += 5 * victim->p_armies;
    }
}

checkmaxkills (pl)
     int pl;
{
  struct stats *stats;
  struct player *dude;

  dude = &(players[pl]);
  stats = &(dude->p_stats);

  if (dude->p_ship.s_type == STARBASE)
    {
      if (stats->st_sbmaxkills < dude->p_kills)
	{
	  stats->st_sbmaxkills = dude->p_kills;
	}
    }
  else if (stats->st_maxkills < dude->p_kills)
    {
      stats->st_maxkills = dude->p_kills;
    }
}


/* update stuff specific to the teams, should be done once/minute */
udteams ()
{
  register int i;

  for (i = 0; i <= MAXTEAM; i++)
    {
      (teams[i].s_turns--);	/* updates starbase repair time! */
    }

  for (i = 0; i < MAXPLANETS; i++)
    {
      if (planets[i].pl_couptime)	/* Decrement coup counter(s) one minute */
	planets[i].pl_couptime--;
    }
}

/* updates planets, grows armies on them, etc */
static int pl_poporder[MAXPLANETS] =
{-1};				/* planet number to pop next */
static int lastpop;		/* pl_poporder index number of planet last popped */
udplanets ()
{

  if (--lastpop < 0)
    RandomizePopOrder ();

  PopPlanet (pl_poporder[lastpop]);
}


PopPlanet (plnum)
     int plnum;
{
  register struct planet *l;
  int num;
  int orig_armies;
  int owner;

  if (debug)
    printf ("populating planet %d\n", plnum);

  if (plnum < 0 || plnum >= MAXPLANETS)
    return;			/* arg sanity */

  l = &planets[plnum];
  owner = remap[l->pl_owner];

  if (l->pl_armies == 0)
    return;


#ifndef NO_PLANET_PLAGUE
#ifdef ERIKPLAGUE
  if (l->pl_armies > 5)
    {
      /* This barely plagues unless you have a HUGE number of armies;
         if you happen to have ~4500, though, you could end up with < 0! */
      num = ((rrandom () % 4500) + (l->pl_armies * l->pl_armies)) / 4500;
      if (num)
	{
	  l->pl_armies -= num;
/* not needed since armies never < 5
   if (l->pl_armies < 5)
   l->pl_flags |= PLREDRAW ;
 */
	  if (nstats)
	    {
	      nstats->team[owner].plague.hit += 1;
	      nstats->team[owner].plague.count += num;
	      if (nstats->team[owner].plague.low <= 0
		  || nstats->team[owner].plague.low > l->pl_armies)
		{
		  nstats->team[owner].plague.low = l->pl_armies;
		}
	    }
	}
    }
#else
  if ((rrandom () % 3000) < l->pl_armies)
    {				/* plague! */
      num = (rrandom () % l->pl_armies);
      l->pl_armies -= num;
      if (nstats)
	{
	  nstats->team[owner].plague.hit += 1;
	  nstats->team[owner].plague.count += num;
	  if (nstats->team[owner].plague.low <= 0
	      || nstats->team[owner].plague.low > l->pl_armies)
	    {
	      nstats->team[owner].plague.low = l->pl_armies;
	    }
	}
      if (l->pl_armies < 5)
	l->pl_flags |= PLREDRAW /* XXX put in client! */ ;
    }
#endif
#endif

  orig_armies = l->pl_armies;

  if (nstats)
    nstats->team[owner].pop.check += 1;

  if (l->pl_armies < 4)
    {
      if (nstats)
	nstats->team[owner].pop.low.check += 1;
      if ((rrandom () % 20) == 0)
	{			/* planets< 4 grow faster */
	  l->pl_armies++;
	  if (nstats)
	    nstats->team[owner].pop.low.hit += 1;
	}
      if (l->pl_flags & PLAGRI)
	{			/* Always grow 1 if Agricultural. */
	  if (nstats)
	    {
	      nstats->team[owner].pop.low_agri.check += 1;
	      if (l->pl_armies == 4)
		nstats->team[owner].pop.low_agri.lucky += 1;
	    }
	  if (++l->pl_armies > 4)
	    l->pl_flags |= PLREDRAW;
	  /* XXX REDRAW in client */
	}
    }

  if ((rrandom () % 10) == 0)
    {				/* Chance for extra armies. */
      if (l->pl_armies < 5)
	l->pl_flags |= PLREDRAW;
      /* XXX REDRAW in client */
      num = (rrandom () % 3) + 1;
      l->pl_armies += num;
    }

  /* Argicultural worlds have extra chance for army growth. */
  if (l->pl_flags & PLAGRI)
    {
      if (nstats)
	nstats->team[owner].pop.agri.check += 1;
      if ((rrandom () % 5) == 0)
	{
	  if (nstats)
	    nstats->team[owner].pop.agri.hit += 1;
	  if (++l->pl_armies > 4)
	    l->pl_flags |= PLREDRAW;
	  /* XXX REDRAW in client */
	}
    }

  num = l->pl_armies - orig_armies;
  if (nstats && num > 0)
    {
      nstats->team[owner].pop.hit += 1;
      nstats->team[owner].pop.num += num;
    }
}

/* reorder order in which planets will be populated
   ** set lastpop to MAXPLANETS */
RandomizePopOrder ()
{
  register int i, j, tmp, tmp2;

  if (debug)
    printf ("Randomizing planetary pop order!\n");

  if (pl_poporder[0] < 0)
    {
      for (i = 0; i < MAXPLANETS; i++)	/* init the pop order table */
	pl_poporder[i] = i;
    }

  /* jmn - optimized based on hadley suggestion */
  for (i = MAXPLANETS - 1; i; i--)
    {
      tmp = (random () % (i + 1));
      tmp2 = pl_poporder[tmp];
      pl_poporder[tmp] = pl_poporder[i];
      pl_poporder[i] = tmp2;
    }

  if (debug)
    {
      printf ("Planet pop order:");
      for (i = 0; i < MAXPLANETS; i++)
	printf (" %d", pl_poporder[i]);
      printf ("\n");
    }

  lastpop = MAXPLANETS - 1;
}

udphaser ()
{
  register int i;
  register struct phaser *j;
  register struct player *victim;

  for (i = 0, j = &phasers[i]; i < MAXPLAYER; i++, j++)
    {
      switch (j->ph_status)
	{
	case PHFREE:
	  continue;
	case PHMISS:
	case PHHIT2:
	  if (j->ph_fuse-- == 1)
	    j->ph_status = PHFREE;
	  break;
	case PHHIT:
	  if (j->ph_fuse-- == players[i].p_ship.s_phaserfuse)
	    {
	      victim = &players[j->ph_target];

	      /* start a war, if necessary */
	      if (players[i].p_hostile & victim->p_team)
		{
		  players[i].p_swar |= victim->p_team;
		}

	      if (victim->p_status == PALIVE)
		{
		  if (victim->p_flags & PFSHIELD)
		    {
		      victim->p_shield -= j->ph_damage;
		      if (victim->p_shield < 0)
			{
			  victim->p_damage -= victim->p_shield;
			  victim->p_shield = 0;
			}
		    }
		  else
		    {
		      victim->p_damage += j->ph_damage;
		    }
		  if (victim->p_damage >= victim->p_ship.s_maxdamage)
		    {
		      victim->p_status = PEXPLODE;
		      if (victim->p_ship.s_type == STARBASE)
			victim->p_explode = 2 * SBEXPVIEWS / PLAYERFUSE;
		      else
			victim->p_explode = 10 / PLAYERFUSE;
		      players[i].p_kills += 1.0 +
			victim->p_armies * 0.1 +
			victim->p_kills * 0.1;
		      killerstats (i, i, victim);
		      checkmaxkills (i);
		      killmess (victim, &players[i], &players[i], KPHASER);
		      loserstats (j->ph_target);
		      victim->p_whydead = KPHASER;
		      victim->p_whodead = i;
		    }
		}
	    }
	  if (j->ph_fuse == 0)
	    j->ph_status = PHFREE;
	  break;
	}
    }
}

int pl_warning[MAXPLANETS];	/* To keep planets shut up for awhile */
int tm_robots[MAXTEAM + 1];	/* To limit the number of robots */
int tm_coup[MAXTEAM + 1];	/* To allow a coup */

teamtimers ()
{
  register int i;
  for (i = 0; i <= MAXTEAM; i++)
    {
      if (tm_robots[i] > 0)
	tm_robots[i]--;
      if (tm_coup[i] > 0)
	tm_coup[i]--;
    }
}

plfight ()
{
  register int h, i;
  register struct player *j;
  register struct planet *l;
  register struct player *pl2;
  int seen;
  int dx, dy;
  int damage;
  int dist;
  int rnd;
  int oldowner = NOBODY;
  int orig_armies;
  char buf[160];
  char buf1[160];
  char addrbuf[10];
  int owner, num;

  for (h = 0, l = &planets[h]; h < MAXPLANETS; h++, l++)
    {
      if (l->pl_flags & PLCOUP)
	{
	  l->pl_flags &= ~PLCOUP;
	  sprintf (addrbuf, "%-3s->%s ", l->pl_name, teamshort[l->pl_owner]);
	  pmessage ("Planet lost in political struggle",
		    l->pl_owner, MTEAM | MCOUP1, addrbuf);
	  l->pl_owner = (l->pl_flags & ALLTEAM);
	  l->pl_armies = 4;
	  sprintf (addrbuf, "%-3s->%s ", l->pl_name, teamshort[l->pl_owner]);
	  pmessage ("Previous dictatorship overthrown in coup d'etat",
		    l->pl_owner, MTEAM | MCOUP2, addrbuf);
	}
      l->pl_flags &= ~PLREDRAW;
      if (pl_warning[h] > 0)
	pl_warning[h]--;
    }
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (j->p_status == PALIVE)
	{

	  seen = 0;
	  for (h = 0, pl2 = &players[0]; h < MAXPLAYER; h++, pl2++)
	    {
	      if (pl2->p_status == PALIVE)
		{
		  if (pl2->p_flags & PFROBOT)
		    continue;
		  if (pl2->p_team != j->p_team)
		    {
		      dx = ABS (pl2->p_x - j->p_x);
		      dy = ABS (pl2->p_y - j->p_y);
		      if (dx > GWIDTH / 3 || dy > GWIDTH / 3)
			continue;
		      dist = (int) hypot ((double) dx, (double) dy);
		      if ((dist < (GWIDTH / 3) && ((j->p_flags & PFCLOAK) == 0))
			  || (dist < (GWIDTH / 7))
			  || ((j->p_flags & PFORBIT) &&
			      (planets[j->p_planet].pl_owner != j->p_team)))
			{
			  seen = 1;
			  break;
			}
		    }
		}
	    }
	  if (seen)
	    {
	      j->p_flags |= PFSEEN;
	    }
	  else
	    {
	      j->p_flags &= ~PFSEEN;
	    }
	  /* Have planets do damage to nearby players.  Note that
	     this is the most inefficient code in the game.  If
	     one needs cycles, simply change the code to have
	     planets only attack ships that are in orbit.   Thus
	     you get rid of the following for statement 
	   */
	  for (h = 0, l = &planets[h]; h < MAXPLANETS; h++, l++)
	    {
	      dx = ABS (l->pl_x - j->p_x);
	      dy = ABS (l->pl_y - j->p_y);
	      if (dx < 3 * PFIREDIST && dy < 3 * PFIREDIST)
		l->pl_flags |= PLREDRAW;
	      if (dx > PFIREDIST || dy > PFIREDIST)	/*XXX */
		continue;
	      dist = (int) hypot ((double) dx, (double) dy);
	      if (dist > PFIREDIST)
		continue;
	      if ((j->p_swar | j->p_hostile) & l->pl_owner)
		{
		  if (l->pl_armies > 0)
		    damage = l->pl_armies / 10 + 2;
		  else
		    damage = 0;
		  if (damage > 0)
		    {
		      if (j->p_flags & PFSHIELD)
			{
			  j->p_shield -= damage;
			  if (j->p_shield < 0)
			    {
			      j->p_damage -= j->p_shield;
			      j->p_shield = 0;
			    }
			}
		      else
			{
			  j->p_damage += damage;
			}
		      if (j->p_damage >= j->p_ship.s_maxdamage)
			{
			  if (j->p_ship.s_type == STARBASE)
			    j->p_explode = 2 * SBEXPVIEWS / PLAYERFUSE;
			  else
			    j->p_explode = 10 / PLAYERFUSE;
			  j->p_status = PEXPLODE;
			  loserstats (i);
			  sprintf (buf1, "");
			  if (j->p_armies)
			    {
			      sprintf (buf1, "+%d", j->p_armies);
			    }
			  (void) sprintf (buf, "%s(%s) (%c%c%s) killed by %s (%c)",
					  j->p_name,
					  shiptypes[j->p_ship.s_type],
					  teamlet[j->p_team],
					  shipnos[j->p_no],
					  buf1,
					  l->pl_name,
					  teamlet[l->pl_owner]);
#ifdef SHORT_PACKETS
			  arg[0] = INLDMKILLP;	/* type */
			  arg[1] = j->p_no;
			  arg[2] = l->pl_no;
			  arg[3] = j->p_armies;
#endif
			  pmessage (buf, 0, MALL | MKILLP, "GOD->ALL");
			  j->p_whydead = KPLANET;
			  j->p_whodead = h;
			}
		    }
		}
	    }			/* End planet damage */

	  /* do bombing */
	  if ((!(j->p_flags & PFORBIT)) || (!(j->p_flags & PFBOMB)))
	    continue;
	  l = &planets[j->p_planet];
	  owner = remap[l->pl_owner];

	  if (!status->tourn)
	    continue;

	  if ((l->pl_owner != INLteams[0]) &&
	      (l->pl_owner != INLteams[1]))
	    continue;

	  if (j->p_team == l->pl_owner)
	    continue;
	  if (!((j->p_swar | j->p_hostile) & l->pl_owner))
	    continue;
	  if (l->pl_armies < 5)
	    continue;

	  /* Warn owning team */
	  if (pl_warning[j->p_planet] <= 0)
	    {
	      pl_warning[j->p_planet] = 50 / PLFIGHTFUSE;
	      (void) sprintf (buf, "We are being attacked by %s %c%c who is %d%% damaged.",
			      j->p_name,
			      teamlet[j->p_team],
			      shipnos[j->p_no],
			      (100 * j->p_damage) / (j->p_ship.s_maxdamage));
	      (void) sprintf (buf1, "%-3s->%-3s",
			      l->pl_name, teamshort[l->pl_owner]);
#ifdef SHORT_PACKETS
	      arg[0] = DMBOMB;	/* type */
	      arg[1] = j->p_no;
	      arg[2] = (100 * j->p_damage) / (j->p_ship.s_maxdamage);
	      arg[3] = l->pl_no;
#endif
	      pmessage (buf, l->pl_owner, MTEAM | MBOMB, buf1);
	    }

	  /* start the war (if necessary) */
	  j->p_swar |= l->pl_owner;

	  /* mark the player info and update tpb if necessary */
	  /* magic number of 5 seconds between bombs to give credit for 
	     2 planets bombed */
	  /* will this crap out if the first planet you bomb== planet #0? */
	  if (status->tourn && (j->lastpbombed != j->p_planet ||
				((ticks - j->whenlastbomb) > 50)
	  /* && j->lastpbombed==j->p_planet :: redundant */ ))
	    {
	      j->p_stats.st_tpb++;
#ifdef STDBG
	      sprintf (buf, "%c%c-> (%s) bombing %s(=%d), last bombed=%d, tpb=%d tab=%d",
		       teamlet[j->p_team], shipnos[j->p_no],
		       shiptypes[j->p_ship.s_type],
		       l->pl_name, j->p_planet,
		       j->lastpbombed, j->p_stats.st_tpb,
		       j->p_stats.st_tarmsbomb);
	      pmessage (buf, j->p_no, MINDIV | MDBG, "");
#endif
	    }
	  j->lastpbombed = j->p_planet;
	  j->whenlastbomb = ticks;
	  if (nstats)
	    {
	      nstats->team[owner].bomb.check += 1;
	      if ((l->pl_flags & PLCORE) && 1 << (l->pl_no % 10) == owner)
		nstats->team[owner].bomb.check_core += 1;
	      if ((l->pl_flags & PLHOME) && 1 << (l->pl_no % 10) == owner)
		nstats->team[owner].bomb.check_home += 1;
	    }
	  rnd = rrandom () % 100;
	  orig_armies = l->pl_armies;
	  if (rnd < 50)
	    {
	      continue;
	    }
	  else if (rnd < 80)
	    {
	      l->pl_armies -= 1;
	      if (l->pl_armies < 5)
		l->pl_flags |= PLREDRAW;
	      j->p_kills += 0.02;
	      j->p_armsbomb += 1;
	      j->p_genoarmsbomb += 1;
	      checkmaxkills (i);
	      /* Give him bombing stats if he is bombing a team with 3+ */
	      if (status->tourn)
		{
		  status->armsbomb++;
		  j->p_stats.st_tarmsbomb++;
		}
	      else
		{
		  j->p_stats.st_armsbomb++;
		}
	    }
	  else if (rnd < 90)
	    {
	      l->pl_armies -= 2;
	      if (l->pl_armies < 5)
		l->pl_flags |= PLREDRAW;
	      j->p_kills += 0.04;
	      j->p_armsbomb += 2;
	      j->p_genoarmsbomb += 2;
	      checkmaxkills (i);
	      if (status->tourn)
		{
		  status->armsbomb += 2;
		  j->p_stats.st_tarmsbomb += 2;
		}
	      else
		{
		  j->p_stats.st_armsbomb += 2;
		}
	    }
	  else
	    {
	      l->pl_armies -= 3;
	      if (l->pl_armies < 5)
		l->pl_flags |= PLREDRAW;
	      j->p_kills += 0.06;
	      j->p_armsbomb += 3;
	      j->p_genoarmsbomb += 3;
	      checkmaxkills (i);
	      if (status->tourn)
		{
		  status->armsbomb += 3;
		  j->p_stats.st_tarmsbomb += 3;
		}
	      else
		{
		  j->p_stats.st_armsbomb += 3;
		}
	    }

	  if ((j->p_ship.s_type == ASSAULT) && (rnd > 20))
	    {
	      /* BUG: "rnd > 20", but above "if (rnd < 50) continue",
	         so rnd is always > 20 if you get here.
	         This code was probably meant to go before the
	         "if (rnd < 50)" and after "rnd = ".
	       */
	      if (nstats)
		{
		  nstats->team[owner].bomb.as += 1;
		  if (l->pl_armies < 4)
		    {
		      nstats->team[owner].bomb.u4_as += 1;
		    }
		}
	      l->pl_armies -= 1;
	      if (l->pl_armies < 5)
		l->pl_flags |= PLREDRAW;
	      j->p_kills += 0.02;
	      j->p_armsbomb += 1;
	      j->p_genoarmsbomb += 1;
	      checkmaxkills (i);
	      if (status->tourn)
		{
		  status->armsbomb += 1;
		  j->p_stats.st_tarmsbomb += 1;
		}
	      else
		{
		  j->p_stats.st_armsbomb += 1;
		}
	    }

	  if (nstats && orig_armies != l->pl_armies)
	    {
	      num = orig_armies - l->pl_armies;
	      nstats->team[owner].bomb.num += num;
	      if (l->pl_armies < 4)
		nstats->team[owner].bomb.u4_num += 4 - l->pl_armies;
	      if ((l->pl_flags & PLCORE) && 1 << (l->pl_no % 10) == owner)
		nstats->team[owner].bomb.core += num;
	      if ((l->pl_flags & PLHOME) && 1 << (l->pl_no % 10) == owner)
		nstats->team[owner].bomb.home += num;
	    }

	  /* Send in a robot if there are no other defenders (or not Tmode)
	     and the planet is in the team's home space */

	  if (((tcount[l->pl_owner] == 0) || (NotTmode (ticks))) &&
	      (l->pl_flags & l->pl_owner) &&
	      tm_robots[l->pl_owner] == 0)
	    {
	      rescue (l->pl_owner, NotTmode (ticks));
	      tm_robots[l->pl_owner] = (1800 +
					(rrandom () % 1800)) /
		TEAMFUSE;
	    }
	}
      else
	{
	  j->p_flags |= PFSEEN;
	}
    }
}

beam ()
{
  register int i, i2, tmp;
  register struct player *j;
  register struct planet *l = NULL;	/* shut the compiler up */
  char buf[160];
  char buf1[160];
  int owner = 0;		/* ditto */

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if ((j->p_status != PALIVE) || !(j->p_flags & (PFORBIT | PFDOCK)))
	continue;
      if (j->p_flags & PFORBIT)
	{
	  l = &planets[j->p_planet];
	  owner = remap[l->pl_owner];
	}
      if (j->p_flags & PFBEAMUP)
	{
	  if (j->p_flags & PFORBIT)
	    if (l->pl_armies < 5)
	      continue;
	  if (j->p_flags & PFDOCK)
	    if (players[j->p_docked].p_armies == 0)
	      continue;
	  if (j->p_armies == j->p_ship.s_maxarmies)
	    continue;
	  /* XXX */
	  if (j->p_ship.s_type == ASSAULT)
	    {
	      if (j->p_armies == (int) (j->p_kills * 3.0))
		continue;
	    }
	  else if (j->p_ship.s_type != STARBASE)
	    if (j->p_armies == (int) (j->p_kills * 2.0))
	      continue;
	  if (j->p_flags & PFORBIT)
	    {
	      if (j->p_team != l->pl_owner)
		continue;
	      if ((j->p_swar | j->p_hostile) & l->pl_owner)
		continue;
	    }

	  j->p_armies++;
	  if (status->tourn)
	    {
	      if (j->p_ship.s_type != STARBASE)
		{
		  j->p_stats.st_tarmscar++;
#ifdef STDBG
		  if (j->p_flags & PFDOCK)
		    {
		      sprintf (buf, "%c%c-> SB gives armies to %c%c. SB>>> have=%d tac=%d tad=%d cak=%d",
			       teamlet[players[j->p_docked].p_team], shipnos[players[j->p_docked].p_no],
			       teamlet[j->p_team], shipnos[j->p_no],
			       players[j->p_docked].p_armies - 1,
			       players[j->p_docked].p_stats.st_tsbarmscar,
			     players[j->p_docked].p_stats.st_tsbarmsdel + 1,
			       players[j->p_docked].p_stats.st_tsbarmsdied);
		      pmessage (buf, players[j->p_docked].p_no, MINDIV | MDBG, "");
		      sprintf (buf, "%c%c-> (%s) beaming up from SB (%c%c) tac=%d tad=%d cak=%d",
			       teamlet[j->p_team], shipnos[j->p_no],
			       shiptypes[j->p_ship.s_type],
			       teamlet[players[j->p_docked].p_team], shipnos[players[j->p_docked].p_no],
			       j->p_stats.st_tarmscar, j->p_stats.st_tarmsdel, j->p_stats.st_tcarmsdied);
		      pmessage (buf, j->p_no, MINDIV | MDBG, "");
		    }
		  else
		    {
		      sprintf (buf, "%c%c-> (%s) beaming up from %s ... have=%d tac=%d tad=%d cak=%d",
			       teamlet[j->p_team], shipnos[j->p_no],
			       shiptypes[j->p_ship.s_type],
			       l->pl_name, j->p_armies,
			     j->p_stats.st_tarmscar, j->p_stats.st_tarmsdel,
			       j->p_stats.st_tcarmsdied);
		      pmessage (buf, j->p_no, MINDIV | MDBG, "");
		    }
#endif
		}
	      else
		{
		  j->p_stats.st_tsbarmscar++;
#ifdef STDBG
		  sprintf (buf, "%c%c-> SB beaming up from %s ... have=%d tac=%d tad=%d cak=%d",
			   teamlet[j->p_team], shipnos[j->p_no], l->pl_name, j->p_armies,
			 j->p_stats.st_tsbarmscar, j->p_stats.st_tsbarmsdel,
			   j->p_stats.st_tsbarmsdied);
		  pmessage (buf, j->p_no, MINDIV | MDBG, "");
#endif
		}

	    }
	  if (status->tourn && (j->p_ship.s_type != STARBASE))
	    {
	      /* acc stuff goes here */
	      for (i2 = 0; (j->mykills[i2] != NULL) && (i2 < 4); i2++)
		{
		  if (j->p_ship.s_type == ASSAULT)
		    {
		      tmp = 3;
		    }
		  else
		    {
		      tmp = 2;
		    }
		  if (j->p_armies > tmp * j->kills_had[i2])
		    {
		      j->kills_had[i2] = 1e19;	/* something huge */
		      j->mykills[i2]->p_stats.st_tacc++;
#ifdef STDBG
		      sprintf (buf, "%c%c-> %c%c gets acc=%d at your armies=%d",
			       teamlet[j->p_team], shipnos[j->p_no],
			       teamlet[j->mykills[i2]->p_team], shipnos[j->mykills[i2]->p_no],
			       j->mykills[i2]->p_stats.st_tacc, j->p_armies);
		      pmessage (buf, j->p_no, MINDIV | MDBG, "");
#endif
		    }
		}
	    }
	  if (j->p_flags & PFORBIT)
	    l->pl_armies--;
	  else if (j->p_flags & PFDOCK)
	    {
	      players[j->p_docked].p_armies--;
	      if (status->tourn)
		players[j->p_docked].p_stats.st_tsbarmsdel++;
	    }
	  continue;
	}
      if (j->p_flags & PFBEAMDOWN)
	{
	  if (j->p_armies == 0)
	    continue;
	  if (j->p_flags & PFORBIT)
	    {
	      if ((!((j->p_swar | j->p_hostile) & l->pl_owner))
		  && (j->p_team != l->pl_owner) && (l->pl_owner != NOBODY))
		continue;
	      if (status->tourn &&
		  (l->pl_owner != INLteams[0]) &&
		  (l->pl_owner != INLteams[1]) &&
		  (l->pl_owner != NOBODY))
		continue;
	      if (j->p_team != l->pl_owner)
		{
		  j->p_armies--;
		  if (l->pl_armies)
		    {
		      int oldowner = l->pl_owner;

		      /* start the war (if necessary) */
		      j->p_swar |= l->pl_owner;

		      if (nstats)
			{
			  nstats->team[owner].drop.num += 1;
			  if (l->pl_armies > 4)
			    nstats->team[owner].drop.dummy += 1;
			  if ((l->pl_flags & PLHOME)
			      && 1 << (l->pl_no % 10) == owner)
			    nstats->team[owner].drop.home += 1;
			  if ((l->pl_flags & PLCORE)
			      && 1 << (l->pl_no % 10) == owner)
			    nstats->team[owner].drop.core += 1;
			}
		      l->pl_armies--;
		      j->p_kills += 0.02;
		      j->p_armsbomb += 1;
		      j->p_genoarmsbomb += 1;
		      checkmaxkills (i);
		      if (status->tourn)
			{	/* dropping on foreign planet */
			  j->p_stats.st_tarmsdel++;
			  status->armsdel++;
			}
		      else
			{
			  /*    j->p_stats.st_armsbomb++; */
			}
		      if (l->pl_armies == 0)
			{
			  /* Give planet to nobody */
			  if (nstats)
			    nstats->team[remap[j->p_team]].
			      planet.destroyed += 1;
			  (void) sprintf (buf, "%s destroyed by %s (%c%c)",
					  l->pl_name,
					  j->p_name,
					  teamlet[j->p_team],
					  shipnos[j->p_no]);
			  (void) sprintf (buf1, "%-3s->%-3s",
					l->pl_name, teamshort[l->pl_owner]);
#ifdef  SHORT_PACKETS
			  arg[0] = DMDEST;	/* type */
			  arg[1] = l->pl_no;
			  arg[2] = j->p_no;
#endif
			  pmessage (buf, l->pl_owner, MTEAM | MDEST, buf1);
			  if (status->tourn &&
			      realNumShips (l->pl_owner) < 2 &&
			      realNumShips (l->pl_flags &
					    (FED | ROM | ORI | KLI)) < 2)
			    {
			      l->pl_flags |= PLCHEAP;
			      /* Next person to take this planet will */
			      /* get limited credit */
			    }
			  l->pl_owner = NOBODY;
			  j->p_stats.st_tpd++;
			  checkwin ();

			  /* out of Tmode?  Terminate.  8/2/91 TC */

			  if (NotTmode (ticks))
			    {
			      if ((l->pl_flags & (FED | ROM | KLI | ORI)) !=
				  j->p_team)	/* not in home quad, give them an extra one 8/26/91 TC */
				rescue (STERMINATOR, j->p_no);
			      rescue (STERMINATOR, j->p_no);
			    }
			  checkgen (oldowner, j);
			  if (!status->gameup)
			    {
			      resettourn ();
			      return;
			    }
			}
		    }
		  else
		    {		/* planet taken over */
		      if (nstats)
			nstats->team[remap[j->p_team]].planet.taken += 1;
		      l->pl_armies++;
		      j->p_planets++;
		      j->p_genoplanets++;
		      if (status->tourn)
			{
			  j->p_stats.st_tarmsdel++;
			  status->armsdel++;
			}
		      if (status->tourn && !(l->pl_flags & PLCHEAP))
			{
			  j->p_stats.st_tplanets++;
			  status->planets++;
#ifdef EXTRACREDIT
			  if ((l->pl_flags & PLCORE) &&
			      !(j->p_team & l->pl_flags) &&
			      (realNumShips (ALLTEAM & l->pl_flags) > 2))
			    {
			      j->p_stats.st_tplanets++;
			      status->planets++;
			    }
#endif
			}
		      else
			{
			  j->p_stats.st_planets++;
			}
		      l->pl_flags &= ~PLCHEAP;

		      j->p_kills += 0.25;
		      checkmaxkills (i);
		      (void) sprintf (buf, "%s taken over by %s (%c%c)",
				      l->pl_name,
				      j->p_name,
				      teamlet[j->p_team],
				      shipnos[j->p_no]);
		      l->pl_owner = j->p_team;
		      l->pl_info = j->p_team;
		      checkwin ();
		      if (!status->gameup)
			{
			  resettourn ();
			  return;
			}

		      /* now tell new team */
		      (void) sprintf (buf1, "%-3s->%-3s",
				      l->pl_name, teamshort[l->pl_owner]);
#ifdef SHORT_PACKETS
		      arg[0] = DMTAKE;	/* type */
		      arg[1] = l->pl_no;
		      arg[2] = j->p_no;
#endif
		      pmessage (buf, l->pl_owner, MTEAM | MTAKE, buf1);
		    }
		}
	      else
		{		/* must be one of our planets */
		  if (status->tourn && l->pl_armies < 4)
		    {
/* not same as bombing  j->p_stats.st_tarmsbomb+=(4 - l->pl_armies);
   status->armsbomb+=(4 - l->pl_armies);
 */

		      /* reinforcement armies count for credit */
		      if (j->p_ship.s_type != STARBASE)
			{
			  j->p_stats.st_tarmsdel++;
			  status->armsdel++;
			}
		      else
			{
			  j->p_stats.st_tsbarmsdel++;
			}
		      if (nstats)
			nstats->team[owner].drop.reinf += 1;
		    }
		  else if (status->tourn)
		    {
		      /* one of our planets with >=4 armies */
		      /* ikko-ikki's suggestion decrement armscarried */
		      if (j->p_ship.s_type != STARBASE)
			{
			  j->p_stats.st_tarmscar--;
			}
		      else
			{
			  j->p_stats.st_tsbarmsdel++;
			}
		    }
		  j->p_armies--;
		  l->pl_armies++;
		}
	    }
	  else if (j->p_flags & PFDOCK)
	    {
	      if (players[j->p_docked].p_team != j->p_team)
		continue;
	      if (players[j->p_docked].p_armies == players[j->p_docked].p_ship.s_maxarmies)
		{
		  continue;
		}
	      else
		{
		  j->p_armies--;
		  /* armies put on base don't count as delivered and we 
		     decrement tarmscar as per ikko-ikki's suggestion */
		  if (status->tourn)
		    {
		      j->p_stats.st_tarmscar--;
		      players[j->p_docked].p_stats.st_tsbarmscar++;
		    }
		  players[j->p_docked].p_armies++;
		}
	    }
#ifdef STDBG
	  if (status->tourn)
	    {
	      if (j->p_flags & PFDOCK)
		{
		  sprintf (buf, "%c%c-> SB gets armies from %c%c have=%d tac=%d tad=%d cak=%d",
			   teamlet[players[j->p_docked].p_team], shipnos[players[j->p_docked].p_no],
			   teamlet[j->p_team], shipnos[j->p_no],
			   players[j->p_docked].p_armies,
			   players[j->p_docked].p_stats.st_tsbarmscar,
			   players[j->p_docked].p_stats.st_tsbarmsdel,
			   players[j->p_docked].p_stats.st_tsbarmsdied);
		  pmessage (buf, players[j->p_docked].p_no, MINDIV | MDBG, "");
		  sprintf (buf, "%c%c-> (%s) beaming down on SB (%c%c) have=%d tac=%d tad=%d cak=%d",
			   teamlet[j->p_team], shipnos[j->p_no],
			   shiptypes[j->p_ship.s_type],
			   teamlet[players[j->p_docked].p_team], shipnos[players[j->p_docked].p_no],
			   j->p_armies,
			   j->p_stats.st_tarmscar, j->p_stats.st_tarmsdel, j->p_stats.st_tcarmsdied);
		  pmessage (buf, j->p_no, MINDIV | MDBG, "");
		}
	      else
		{
		  sprintf (buf, "%c%c-> (%s) beamed down on %s (%c) have=%d tac=%d tad=%d cak=%d",
			   teamlet[j->p_team], shipnos[j->p_no],
			   shiptypes[j->p_ship.s_type],
			   l->pl_name, teamlet[l->pl_owner],
			   j->p_armies,
			   (j->p_ship.s_type == STARBASE) ? j->p_stats.st_tsbarmscar : j->p_stats.st_tarmscar,
			   (j->p_ship.s_type == STARBASE) ? j->p_stats.st_tsbarmsdel : j->p_stats.st_tarmsdel,
			   (j->p_ship.s_type == STARBASE) ? j->p_stats.st_tsbarmsdied : j->p_stats.st_tcarmsdied);
		  pmessage (buf, j->p_no, MINDIV | MDBG, "");
		}
	    }
#endif
	}
    }
}

blowup (sh)
     struct player *sh;
{
  register int i;
  int dx, dy, dist;
  int damage;
  register struct player *j;
  register struct player *k;

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (j->p_status != PALIVE)
	continue;
      if (sh == j)
	continue;
      /* the following keeps people from blowing up on others */
      me = sh;
      if ((me->p_whydead == KQUIT) && (friendlyPlayer (j)))
	continue;
      dx = sh->p_x - j->p_x;
      dy = sh->p_y - j->p_y;
      if (ABS (dx) > SHIPDAMDIST || ABS (dy) > SHIPDAMDIST)
	continue;
      dist = dx * dx + dy * dy;
      if (dist > SHIPDAMDIST * SHIPDAMDIST)
	continue;
      if (dist > EXPDIST * EXPDIST)
	{
	  if (sh->p_ship.s_type == STARBASE)
	    damage = 200 * (SHIPDAMDIST - sqrt ((double) dist)) /
	      (SHIPDAMDIST - EXPDIST);
	  else if (sh->p_ship.s_type == SCOUT)
	    damage = 75 * (SHIPDAMDIST - sqrt ((double) dist)) /
	      (SHIPDAMDIST - EXPDIST);
	  else
	    damage = 100 * (SHIPDAMDIST - sqrt ((double) dist)) /
	      (SHIPDAMDIST - EXPDIST);
	}
      else
	{
	  if (sh->p_ship.s_type == STARBASE)
	    damage = 200;
	  else if (sh->p_ship.s_type == SCOUT)
	    damage = 75;
	  else
	    damage = 100;
	}
      if (damage > 0)
	{
	  if (j->p_flags & PFSHIELD)
	    {
	      j->p_shield -= damage;
	      if (j->p_shield < 0)
		{
		  j->p_damage -= j->p_shield;
		  j->p_shield = 0;
		}
	    }
	  else
	    {
	      j->p_damage += damage;
	    }
	  if (j->p_damage >= j->p_ship.s_maxdamage)
	    {
	      j->p_status = PEXPLODE;
	      if (j->p_ship.s_type == STARBASE)
		j->p_explode = 2 * SBEXPVIEWS;
	      else
		j->p_explode = 10;

	      if ((j->p_no != sh->p_whodead) &&
		  (j->p_team != players[sh->p_whodead].p_team) &&
		  (sh->p_whydead == KSHIP || sh->p_whydead == KTORP ||
		   sh->p_whydead == KPHASER || sh->p_whydead == KPLASMA))
		k = &players[sh->p_whodead];
	      else
		k = sh;
	      if ((k->p_team != j->p_team) ||
		  ((k->p_team == j->p_team) && !(j->p_flags & PFPRACTR)))
		{
		  k->p_kills += 1.0 + j->p_armies * 0.1 + j->p_kills * 0.1;
		  checkmaxkills (k->p_no);
		}
	      killerstats ( /* credit kill */ k->p_no,
	      /* real killer */ sh->p_no, j);
	      loserstats (i);
	      j->p_whydead = KSHIP;
	      j->p_whodead = k->p_no;
	      killmess (j, /* credit kill */ k,
	      /* real killer */ sh,
			(k->p_no == sh->p_no) ? KSHIP : KSHIP2);
	    }
	}
    }
}

print_inl_stats ()
{
  FILE *statfp;			/* so we can use stdio */
  int pfd;
  struct statentry this_player;

  statfp = fopen (INL_STATFILE, "w");
  pfd = open (PLAYERFILE, O_RDONLY, 0744);

  fprintf (statfp, "%-16s%10s%10s%10s%10s%10s\n",
	   "Name", "Seconds", "Armies", "Planets", "Kills", "Losses");
  fprintf (statfp, "Globals:\n");
  fprintf (statfp, "%16s%10d%4d(%4d)%10d%10d%10d\n", "",
	   status->timeprod, status->armsbomb, status->armsogged, status->planets, status->kills, status->losses);

  fprintf (statfp, "Players:\n");

  while (read (pfd, &this_player, sizeof (struct statentry)) > 0)
      fprintf (statfp, "%-16s%10d%4d(%4d)%10d%10d%10d\n", this_player.name,
	       this_player.stats.st_tticks, this_player.stats.st_tarmsbomb,
	       this_player.stats.st_tarmsogged,
	       this_player.stats.st_tplanets, this_player.stats.st_tkills,
	       this_player.stats.st_tlosses);
  fprintf (statfp, "\n");

  lseek (pfd, (long) 0, 0);
  fprintf (statfp, "Starbase:\n");
  fprintf (statfp, "%-16s%10s%10s%10s%10s\n",
	   "Name", "Seconds", "Kills", "Losses", "Maxkills");
  while (read (pfd, &this_player, sizeof (struct statentry)) > 0)
    if (this_player.stats.st_tsbticks > 1)
        fprintf (statfp, "%-16s%10d%10d%10d%10lf\n",
		 this_player.name, this_player.stats.st_tsbticks,
	      this_player.stats.st_tsbkills, this_player.stats.st_tsblosses,
		 this_player.stats.st_sbmaxkills);

  fprintf (statfp, "\n\n --------- End of Stats --------- \n\n");

  fclose (statfp);
  close (pfd);
}

freemem (sig, code, scp)
     int sig, code;
     struct sigcontext *scp;
{
  register int i;
  register struct player *j;
  FILE *logfile;
  long timeoday;

  if (sig == SIGFPE)
    return;			/* Too many errors occur ... ignore them. */

  (void) SIGNAL (SIGALRM, SIG_IGN);

  if (sig)
    {
      /* if it crashed we want to know why */
      fprintf (stderr, "daemonII going down on signal %d\n", sig);
      fflush (stderr);

      switch (sig)
	{
	case SIGSEGV:
	case SIGBUS:
	  /* segv or bus error always suggests a big bug somewhere..
	     I think its better to crash right here and leave the
	     shared memory segment in place, that way 'xsg' can be
	     used to look for weirdness in the game. */

	  /* reset so we don't re-enter */
	  (void) SIGNAL (SIGQUIT, SIG_DFL);
	  (void) SIGNAL (SIGILL, SIG_DFL);
	  (void) SIGNAL (SIGTRAP, SIG_DFL);
	  (void) SIGNAL (SIGABRT, SIG_DFL);
	  (void) SIGNAL (SIGBUS, SIG_DFL);
	  (void) SIGNAL (SIGSEGV, SIG_DFL);
	  abort ();
	default:
	  break;
	}
    }

  /* Blow players out of the game */
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
#ifdef DS
      if (j->p_process > 1)
	(void) kill (j->p_process, SIGTERM);
#endif
      j->p_status = POUTFIT;
      j->p_whydead = KDAEMON;
      j->p_ntorp = 0;
      j->p_nplasmatorp = 0;
      j->p_explode = 600 / PLAYERFUSE;	/* ghost buster was leaving players in */
    }
  savetourn ();

  /* kill anything on the queue */
  for (i = 0; i < MAXQUEUE; i++)
    {
      if (sharedMemory->Wait_Queue[0].Queue_List[i] > 1)
	kill (sharedMemory->Wait_Queue[0].Queue_List[i], SIGTERM);
    }

#ifdef USE_MMAP
  {
#ifdef BACKUP_MMAP_FILE
    char backup[50];
    sprintf (backup, "sharedMem.%d", getpid ());
    if (link ("sharedMem", backup) < 0)
      perror ("daemon: can't backup shared memory file");
#endif
    if (unlink ("sharedMem") < 0)
      perror ("daemon: can't remove shared memory file");
  }
#else
#ifndef MACH
  shmctl (shmid, IPC_RMID, (struct shmid_ds *) 0);
#endif	/* MACH */
#endif	/* USE_MMAP */
  start_Tourn_sec = 0;
  if (status->tourn)
    {
      /* ignore SIGALRM so our script doesn't quit */
      regtourn (1);
    }
  exit (0);
}

save_planets ()
{
  if (plfd >= 0)
    {
      (void) lseek (plfd, (long) 0, 0);
      (void) write (plfd, (char *) planets, sizeof (pdata));
    }
  if (glfd >= 0)
    {
      (void) lseek (glfd, (long) 0, 0);
      (void) write (glfd, (char *) status, sizeof (struct status));
    }
}

check_load ()
{
  FILE *fp, *popen ();
  char buf[100];
#ifdef SOLARIS2
  char *s;
#else
  char *s, *rindex ();
#endif
  float load;

  return;
#ifdef notdef
  fp = popen ("/usr/ucb/uptime", "r");
  if (fp == NULL)
    {
/*      status->gameup=0; */
      return;
    }
  fgets (buf, 99, fp);
  s = rindex (buf, ':');
  if (s == NULL)
    {
/*      status->gameup=0; */
      pclose (fp);
      return;
    }
  if (sscanf (s + 1, " %f", &load) == 1)
    {
      if (load >= maxload && status->gameup == 1)
	{
	  status->gameup = 0;
	  sprintf (buf, "The load is %f, this game is going down", load);
	  pmessage (buf, 0, MALL, "GOD->ALL");
	}
      else if (load < maxload && status->gameup == 0)
	{
	  status->gameup = 1;
	  sprintf (buf, "The load is %f, this game is coming up", load);
	  pmessage (buf, 0, MALL, "GOD->ALL");
	}
      else
	{
	  sprintf (buf, "Load check%s", s);
	  buf[strlen (buf) - 1] = '\0';
	  pmessage (buf, 0, MALL, "GOD->ALL");
	}
    }
  else
    {
/*      status->gameup=0; */
    }
  SIGNAL (SIGCHLD, SIG_DFL);
  pclose (fp);
  SIGNAL (SIGCHLD, reaper);
#endif
}

/* This function checks to see if a team has been genocided --
   their last planet has been beamed down to zero.  It will set
   a timer on their home planet that will prevent them from
   couping for a random number of minutes.
 */
checkgen (loser, winner)
     int loser;
     struct player *winner;
{
  register int i;
  register struct planet *l;
  struct planet *homep;
  struct player *j;

  for (i = 0; i < MAXTEAM; i++)
    teams[i].s_plcount = 0;

  for (i = 0, l = &planets[i]; i < MAXPLANETS; i++, l++)
    {
      teams[l->pl_owner].s_plcount++;	/* for now, recompute here */
/*      if (l->pl_owner == loser)
   return; */
      if (((l->pl_flags & ALLTEAM) == loser) && (l->pl_flags & PLHOME))
	homep = l;		/* Keep track of his home planet for marking */
    }

  if (teams[loser].s_plcount > 0)
    return;

  /* Give extra credit for neutralizing last planet! */
  winner->p_genoplanets++;
#ifdef EXTRACREDIT
  winner->p_planets++;
  if (status->tourn)
    {
      winner->p_stats.st_tplanets++;
    }
  else
    {
      winner->p_stats.st_planets++;
    }
#endif

  /* just make check for resettourn after checkgen() due to this */
  checkwin ();
  /* That will end the game */
}


/* This function is called at the end of the INL game, and then every 
   time a planet is taken over or neutralized.  RJ INL
 */
checkwin ()
{
  register int i, h, count;
  register struct planet *l;
  register struct player *j;
  register int homecount, visitcount;

  int victcount = 11;		/* minimum planets required for a win */
  int losecount = 8;		/* team with this or less plants loses */

#ifdef PLAYOFF
  /* playoff mode, where there can be no ties.  planets required for a 
     ** win change in this mode
   */
  switch (*INL_period)
    {
    case 0:
      victcount = 11;
      losecount = 8;
      break;
    case 1:
      victcount = 11;
      losecount = 8;
      break;
    case 2:
      victcount = 11;
      losecount = 9;
      break;
    default:
      victcount = 10;
      losecount = 9;
      break;
    }

#endif


  homecount = 0;
  visitcount = 0;

  teams[0].s_plcount = 0;
  for (i = 0; i < 4; i++)
    {
      teams[1 << i].s_plcount = 0;
    }

  for (i = 0, l = &planets[i]; i < MAXPLANETS; i++, l++)
    {
      teams[l->pl_owner].s_plcount++;
      if (l->pl_owner == INLteams[0])
	{
	  homecount++;
	}
      else if (l->pl_owner == INLteams[1])
	{
	  visitcount++;
	}
    }

  /* hometeam victory */
  if (((homecount >= victcount) && (visitcount <= losecount) && (INL_tournend))
      || (visitcount == 0))
    {
      announceConq (0, 1);
      return;
    }

  if (((homecount <= losecount) && (visitcount >= victcount) && (INL_tournend))
      || (homecount == 0))
    {
      announceConq (1, 0);
      return;
    }

#ifndef PLAYOFF
  /* non-playoff game, take down game if reached end of Overtime */
  if (INL_tournend &&
      (*INL_timeleft == 0) &&
      status->tourn &&
      (*INL_period >= 2))
    {

      /* OT ended with no winner */
      status->gameup = 0;
      status->tourn = 0;
      plcountMessage (INLteams[1], INLteams[0]);
    }
#endif
}


announceConq (winner, twinks)
     int winner, twinks;
{
  int h;
  struct player *j;

  conquerMessage (INLteams[winner], INLteams[twinks]);
  plcountMessage (INLteams[winner], INLteams[twinks]);
  for (h = 0, j = &players[0]; h < MAXPLAYER; h++, j++)
    {
      if (j->p_status == PFREE)
	continue;
      j->p_status = PEXPLODE;
      j->p_whydead = KTOURNEND;
      if (j->p_ship.s_type == STARBASE)
	j->p_explode = 2 * SBEXPVIEWS / PLAYERFUSE;
      else
	j->p_explode = 10 / PLAYERFUSE;
      j->p_ntorp = 0;
      j->p_nplasmatorp = 0;
    }
  INL_die_complete = 1;
  status->gameup = 0;
  status->tourn = 0;
}

void
copy80 (dest, addr_format, address, str)

     char *dest;
     char *addr_format;
     char *address;
     char *str;
{
  char addr_buf[64];
  int l;

  sprintf (addr_buf, addr_format, address);
  l = strlen (addr_buf);
  strncpy (dest, addr_buf, l);
  strncpy (&dest[l], str, 79 - l);
  dest[79] = '\0';
}


pmessage (str, recip, group, address)
     char *str;
     int recip;
     int group;
     char *address;
{
  struct message *cur;
  int mesgnum;

  if ((mesgnum = ++(mctl->mc_current)) >= MAXMESSAGE)
    {
      mctl->mc_current = 0;
      mesgnum = 0;
    }
  cur = &messages[mesgnum];
  cur->m_no = mesgnum;
  cur->m_flags = group;
  cur->m_recpt = recip;
  cur->m_from = 255;		/* From god */
  if (address && *address)
    copy80 (cur->m_data, "%-9s ", address, str);
  else
    {
      strncpy (cur->m_data, str, 79);
      cur->m_data[79] = 0;
    }
  cur->m_flags |= MVALID;
#ifdef SHORT_PACKETS
  if (arg[0] != DINVALID)
    {
      cur->args[0] = arg[0];
      cur->args[1] = arg[1];
      cur->args[2] = arg[2];
      cur->args[3] = arg[3];
      cur->args[4] = arg[4];
      cur->args[5] = arg[5];
    }
  else
    {
      if (strstr (address, "GOD->") != NULL)
	cur->args[0] = SVALID;	/* It has a real header */
      else
	cur->args[0] = SINVALID;
      /* Marked as invalid to send over */
      /* SP_S_WARNING  and SP_S_MESSAGE HW */
    }
  arg[0] = DINVALID;
#endif
}

ghostmess (victim)
     struct player *victim;
{
  char buf[80];
  static float ghostkills = 0.0;
  int i, k;

  ghostkills += 1.0 + victim->p_armies * 0.1 + victim->p_kills * 0.1;
  (void) sprintf (buf, "%s(%s) (%c%c) was kill %0.2f for the GhostBusters",
		  victim->p_name, shiptypes[victim->p_ship.s_type],
		  teamlet[victim->p_team], shipnos[victim->p_no],
		  ghostkills);
#ifdef SHORT_PACKETS
  arg[0] = DGHOSTKILL;		/* type */
  arg[1] = victim->p_no;
  arg[2] = 100 * ghostkills;
#endif
  pmessage (buf, 0, MALL, "GOD->ALL");
  if (victim->p_armies > 0)
    {
      k = 10 * (remap[victim->p_team] - 1);
      if (k >= 0 && k <= 30)
	for (i = 0; i < 10; i++)
	  {
	    if (planets[i + k].pl_owner == victim->p_team)
	      {
		planets[i + k].pl_armies += victim->p_armies;
		(void) sprintf (buf, "%s's %d armies placed on %s",
		  victim->p_name, victim->p_armies, planets[k + i].pl_name);
		pmessage (buf, 0, MALL | MGHOST, "GOD->ALL");
		break;
	      }
	  }
    }
}

saveplayer (victim)
     struct player *victim;
{
  int fd;

  if (victim->p_pos < 0)
    return;
  if (victim->p_stats.st_lastlogin == 0)
    return;
  if (victim->p_flags & PFROBOT)
    return;

  fd = open (PLAYERFILE, O_WRONLY, 0644);
  /* if he died cause of gb or quitting or whatever other rudeness 
     make sure his tarmscar stat isn't hosed */
  /* NOTE: this incorrectly decrements tarmscar if a player quits after being
     ogged -- p_armies is only set to 0 by ntserv'enter() */
  if (status->tourn)
    {
      if (victim->p_ship.s_type != STARBASE)
	{
	  victim->p_stats.st_tarmscar -= victim->p_armies;
	}
      else
	{
	  victim->p_stats.st_tsbarmscar -= victim->p_armies;
	}
    }
  victim->p_armies = 0;
  if (fd >= 0)
    {
      lseek (fd, 32 + victim->p_pos * sizeof (struct statentry), 0);
      write (fd, (char *) &victim->p_stats, sizeof (struct stats));
      close (fd);
    }
}

char *whydeadmess[] =
{"", "", "[photon]", "[phaser]", "", "[explosion]",
 "", "", "", "", "", "[plasma]", "[detted photon]", "[chain explosion]",
 "[TEAM]", "", "[team det]", "[team explosion]"};

killmess (victim, credit_killer, killer, whydead)
     struct player *victim, *credit_killer, *killer;
{
  char buf[80];
  char *why = NULL;
  char kills[20];
#ifdef SHORT_PACKETS
  int reason;
#endif

  /* if R1 explodes killing R2 who kills F3, figure R2 should get the
     credit, not R1 */
  if (credit_killer->p_team == killer->p_team)
    credit_killer = killer;

  sprintf (kills, "%0.2f", killer->p_kills);

  /* I've changed this so that victims with armies killed by teammates
     also show NO CREDIT -tsh */

  if ( /* whymess */ 1)
    {
      if ((victim->p_team == killer->p_team) &&
	  !(victim->p_flags & PFPRACTR) /* && victim->p_armies==0 */ )
	{
#ifdef SHORT_PACKETS
	  reason = whydead;	/* why 14? */
#endif
	  why = whydeadmess[whydead];
	  strcpy (kills, "NO CREDIT");
/*              killer->p_kills = 0.0; this is wrong - jmn */
/* hopefully we didn't give him credit to start with - jmn  (yes) */
	}
      else
	{
#ifdef SHORT_PACKETS
	  reason = whydead;
#endif
	  why = whydeadmess[whydead];
	}
    }

  if (victim->p_armies == 0)
    {
      (void) sprintf (buf, "%s(%s) (%c%c) was kill %s for %s(%s) (%c%c)",
		      victim->p_name,
		      shiptypes[victim->p_ship.s_type],
		      teamlet[victim->p_team],
		      shipnos[victim->p_no],
		      kills,
		      killer->p_name,
		      shiptypes[killer->p_ship.s_type],
		      teamlet[killer->p_team],
		      shipnos[killer->p_no]);
#ifdef  SHORT_PACKETS
      arg[0] = INLDMKILL;	/* type */
      arg[1] = victim->p_no;
      arg[2] = killer->p_no;
      arg[3] = 100 * killer->p_kills;
      arg[4] = 0;
      arg[5] = reason;
#endif
      if ( /* whymess */ 1)
	sprintf (buf, "%-50s %s", buf, why);

      if (strlen (buf) > MSG_LEN)
	buf[MSG_LEN] = '\0';

      pmessage (buf, 0, MALL | MKILL, "GOD->ALL");

      /* now here's the problem: if killer != credit_killer we don't
         see a message for credit_killer, although he gets kills and
         army credit.  One possible solution?  Send a followup message. 
         -tsh */

      if (killer != credit_killer)
	{
	  (void) sprintf (buf, "Credit for %c%c awarded to %s(%s) (%c%c), kill %0.2f",
			  teamlet[victim->p_team],
			  shipnos[victim->p_no],
			  credit_killer->p_name,
			  shiptypes[credit_killer->p_ship.s_type],
			  teamlet[credit_killer->p_team],
			  shipnos[credit_killer->p_no],
			  credit_killer->p_kills);

	  /* if we use SHORT_PACKETS args here the message won't be
	     distinguishable from a kill message, thus a player would
	     see 2 kill messages for the same kill -tsh */
	  pmessage (buf, 0, MALL | MKILL, "GOD->ALL");
	}

    }
  else
    {
      (void) sprintf (buf, "%s(%s) (%c%c+%d armies) was kill %s for %s(%s) (%c%c)",
		      victim->p_name,
		      shiptypes[victim->p_ship.s_type],
		      teamlet[victim->p_team],
		      shipnos[victim->p_no],
		      victim->p_armies,
		      kills,	/* was killer->p_kills */
		      killer->p_name,
		      shiptypes[killer->p_ship.s_type],
		      teamlet[killer->p_team],
		      shipnos[killer->p_no]);
#ifdef SHORT_PACKETS
      arg[0] = INLDMKILL;	/* type */
      arg[1] = victim->p_no;
      arg[2] = killer->p_no;
      arg[3] = 100 * killer->p_kills;
      arg[4] = victim->p_armies;
      arg[5] = reason;
#endif
      if ( /* whymess */ 1)
	sprintf (buf, "%-50s %s", buf, why);

      if (strlen (buf) > MSG_LEN)
	buf[MSG_LEN] = '\0';

      pmessage (buf, 0, MALL | MKILLA, "GOD->ALL");

      /* if killer != credit_killer we don't see a message for
         credit_killer, although he gets kills and army credit.  One
         possible solution?  Send a followup message. -tsh */

      if (killer != credit_killer)
	{
	  (void) sprintf (buf, "Credit for %c%c+%d armies awarded to %s(%s) (%c%c), kill %0.2f",
			  teamlet[victim->p_team],
			  shipnos[victim->p_no],
			  victim->p_armies,
			  credit_killer->p_name,
			  shiptypes[credit_killer->p_ship.s_type],
			  teamlet[credit_killer->p_team],
			  shipnos[credit_killer->p_no],
			  credit_killer->p_kills);

	  /* if we use SHORT_PACKETS args here the message won't be
	     distinguishable from a kill message, thus a player would
	     see 2 kill messages for the same kill -tsh */
	  pmessage (buf, 0, MALL | MKILLA, "GOD->ALL");
	}
    }
}

/* Send in a robot to avenge the aggrieved team */
/* -1 for HK, -2 for Terminator, -3 for sticky Terminator */

/* if team in { FED, ROM, KLI, ORI }, a nonzero target means "fleet" mode */
rescue (team, target)
     int team;
     int target;
{
  char *arg1;
  int pid;

  return;			/* RJ INL */
}

#include <sys/resource.h>

reaper (sig)
{
#if !defined(SOLARIS2) && !defined(__osf__)
  static union wait status;
#else
  int status;
#endif
  static int pid;

#ifdef ULTRIX
  while ((pid = wait2 (&status, WNOHANG, (struct rusage *) 0)) > 0)
    {
#else
#if defined(SOLARIS2) || defined(__osf__)
  while ((pid = waitpid((pid_t) 0, &status, WNOHANG)) > 0)
    {
#else
  while ((pid = wait3 (&status, WNOHANG, (struct rusage *) 0)) > 0)
    {
#endif
#endif
      if (debug)
	{
	  fprintf (stderr, "Reaping: pid is %d (status: %lX)\n",
		   pid, status);
	}
    }
}

unsigned char
getcourse (x, y, xme, yme)
     int x, y, xme, yme;
{
  return ((unsigned char) (atan2 ((double) (x - xme),
				  (double) (yme - y)) / 3.14159 * 128.));
}


unsigned char
get_bearing (xme, yme, x, y, dir)
     int x, y;
{
  int phi = 0;

  phi = ((int) (atan2 ((double) (x - xme), (double) (yme - y)) / 3.14159 * 128.));
  if (phi < 0)
    phi = 256 + phi;
  if (phi >= dir)
    return ((unsigned char) (phi - dir));
  else
    return ((unsigned char) (256 + phi - dir));
}

/* 
 * Find nearest hostile vessel and indicate if it is on the right or the left
 *   of the current heading.  A return value of -1 means left and +1 means right. 
 */
int 
torp_track_target (torp)
     struct torp *torp;
{
  int i, closest = -1, min_dist = GWIDTH * 2, dist = 0, war_mask, x, y,
    owner;
  unsigned char phi = 0, bearing = 0, dir = 0;

  x = torp->t_x;
  y = torp->t_y;
  dir = torp->t_dir;
  owner = torp->t_owner;
  war_mask = torp->t_war;
  for (i = 0; i < MAXPLAYER; i++)
    {
      if ((isAlive (&players[i])) &&
	  ((owner != i && (war_mask & players[i].p_team)) ||
      (players[owner].p_team & (players[i].p_hostile | players[i].p_swar))))
	{
	  bearing = get_bearing (x, y, players[i].p_x, players[i].p_y, dir);
	  /* 
	     * An approximation to prevent the torpedo from tracking unreasonable targets:
	     * If target is in an arc that the torp might reach, then it is valid.
	   */
	  /*
	     * fprintf(stderr, "Target %d bearing [%d]:  heading %d,  fuse %d\n", i, 
	     *      (int) bearing, (int) dir, torp->t_fuse);
	   */
	  if ((torp->t_turns * torp->t_fuse > 127) ||
	      (bearing < ((unsigned char) torp->t_turns * torp->t_fuse)) ||
	  (bearing > ((unsigned char) (256 - torp->t_turns * torp->t_fuse))))
	    {
	      dist = ((int) hypot ((double) (x - players[i].p_x),
				   (double) (y - players[i].p_y)));
	      if (dist < min_dist)
		{
		  min_dist = dist;
		  closest = i;
		}
	    }
	}
    }

  if (closest >= 0)
    {
      if (get_bearing (x, y, players[closest].p_x, players[closest].p_y, dir) > 128)
	return (-1);		/* Target is on the left. */
      else
	return (1);		/* Target is on the right. */
    }

  return (0);			/* No target ... go straight. */
}				/* torp_track_target() ------------------------------------------------- */

/* 
 * Find nearest hostile vessel and indicate if it is on the right or the left
 *   of the current heading.  A return value of -1 means left and +1 means right. 
 */
int 
plasma_track_target (torp)
     struct plasmatorp *torp;
{
  int i, closest = -1, min_dist = GWIDTH * 2, dist = 0, war_mask, x, y,
    owner;
  unsigned char phi = 0, bearing = 0, dir = 0;

  x = torp->pt_x;
  y = torp->pt_y;
  dir = torp->pt_dir;
  owner = torp->pt_owner;
  war_mask = torp->pt_war;
  for (i = 0; i < MAXPLAYER; i++)
    {
      if ((isAlive (&players[i])) &&
	  ((owner != i && (war_mask & players[i].p_team)) ||
      (players[owner].p_team & (players[i].p_hostile | players[i].p_swar))))
	{
	  bearing = get_bearing (x, y, players[i].p_x, players[i].p_y, dir);
	  /* 
	     * An approximation to prevent the torpedo from tracking unreasonable targets:
	     * If target is in an arc that the torp might reach, then it is valid.
	   */
	  /*
	     * fprintf(stderr, "Target %d bearing [%d]:  heading %d,  fuse %d\n", i, 
	     *      (int) bearing, (int) dir, torp->pt_fuse);
	   */
	  if ((torp->pt_turns * torp->pt_fuse > 127) ||
	      (bearing < ((unsigned char) torp->pt_turns * torp->pt_fuse)) ||
	      (bearing > ((unsigned char) (256 - torp->pt_turns * torp->pt_fuse))))
	    {
	      dist = ((int) hypot ((double) (x - players[i].p_x),
				   (double) (y - players[i].p_y)));
	      if (dist < min_dist)
		{
		  min_dist = dist;
		  closest = i;
		}
	    }
	}
    }

  if (closest >= 0)
    {
      if (get_bearing (x, y, players[closest].p_x, players[closest].p_y, dir) > 128)
	return (-1);		/* Target is on the left. */
      else
	return (1);		/* Target is on the right. */
    }

  return (0);			/* No target ... go straight. */
}				/* plasma_track_target() ------------------------------------------------- */

/* Give more troops to winning team in case they need them. */
addTroops (loser, winner)
     int loser, winner;
{
  int count = 0;
  int i;
  char addrbuf[10];

  for (i = 0; i < MAXPLAYER; i++)
    {
      if (players[i].p_status != PFREE && players[i].p_team == loser)
	count++;
    }
  /* Never give armies if 0-2 defenders */
  if (count < 3)
    return;
  /* Sometimes give armies if 3-5 defenders */
  if (count < 6 && (rrandom () % count) == 0)
    return;
  /* Always give armies if 6+ defenders */
  sprintf (addrbuf, "GOD->%s ", teamshort[winner]);
  pmessage ("The recent victory has boosted enrollment!", winner, MTEAM, addrbuf);
  for (i = 0; i < MAXPLANETS; i++)
    {
      if (planets[i].pl_owner == winner)
	{
	  planets[i].pl_armies += rrandom () % (2 * count);
	}
    }
}

plcountMessage (winner, loser)
     int winner, loser;
{
  int i;
  int tot[9];
  FILE *conqfile;

  bzero (tot, sizeof (tot));

  save_nstats ();

  conqfile = fopen (CONQFILE, "a");
  fprintf (conqfile, "Home Team: %s, Away Team: %s\n",
	   INLteams[0] == winner ? teamshort[winner] : teamshort[loser],
	   INLteams[0] == winner ? teamshort[loser] : teamshort[winner]);
  fprintf (conqfile, "Planet Distribution at End of game:\n");
  fprintf (conqfile, "%-6s %-15s %-6s %-6s\n",
	   "Owner", "Planet", "Armies", "Flags");
  for (i = 0; i < 40; i++)
    {
      if (planets[i].pl_owner == winner || planets[i].pl_owner == 0)
	{
	  fprintf (conqfile, "%-6s %-15s %6d %s%s%s%s\n",
		   teamshort[planets[i].pl_owner], planets[i].pl_name,
		   planets[i].pl_armies,
		   planets[i].pl_flags & PLCORE ? "CORE " : "",
		   planets[i].pl_flags & PLFUEL ? "FUEL " : "",
		   planets[i].pl_flags & PLREPAIR ? "REPAIR " : "",
		   planets[i].pl_flags & PLAGRI ? "AGRI" : "");
	}
    }

  fprintf (conqfile, "\n");
  for (i = 0; i < 40; i++)
    {
      if (planets[i].pl_owner == loser)
	{
	  fprintf (conqfile, "%-6s %-15s %6d %s%s%s%s\n",
		   teamshort[planets[i].pl_owner], planets[i].pl_name,
		   planets[i].pl_armies,
		   planets[i].pl_flags & PLCORE ? "CORE " : "",
		   planets[i].pl_flags & PLFUEL ? "FUEL " : "",
		   planets[i].pl_flags & PLREPAIR ? "REPAIR " : "",
		   planets[i].pl_flags & PLAGRI ? "AGRI " : "");
	}
      tot[planets[i].pl_owner]++;
    }
  fprintf (conqfile, "Planet Totals: %s vs. %s, %s-%s, %d-%d-%d.\n",
	   INLteams[0] == winner ? teamname[0] : teamname[1],
	   INLteams[0] == winner ? teamname[1] : teamname[0], teamshort[winner], teamshort[loser],
	   tot[winner], tot[loser], tot[0]);

  fclose (conqfile);
}

conquerMessage (winner, loser)
     int winner, loser;
{
  char buf[80];
  long curtime;
  FILE *conqfile;
  char *wint;
  char *lost;

  conqfile = fopen (CONQFILE, "a");

  if (INLteams[0] == winner)
    {
      wint = teamname[0];
      lost = teamname[1];
    }
  else
    {
      wint = teamname[1];
      lost = teamname[0];
    }


  time (&curtime);
  strcpy (buf, "\nConquer! ");
  strcat (buf, ctime (&curtime));
  fprintf (conqfile, "  %s\n", buf);

  pmessage ("***********************************************************",
	    0, MALL | MCONQ, "");
  sprintf (buf, "The galaxy has been conquered by the %s(%s):", teamNames[winner], wint);
  pmessage (buf, 0, MALL | MCONQ, "");
  fprintf (conqfile, "  %s\n", buf);
  sprintf (buf, "The %s(%s):", teamNames[winner], wint);
  pmessage (buf, 0, MALL | MCONQ, "");
  fprintf (conqfile, "  %s\n", buf);
  displayBest (conqfile, winner, KWINNER);
  sprintf (buf, "The %s(%s):", teamNames[loser], lost);
  pmessage (buf, 0, MALL | MCONQ, "");
  fprintf (conqfile, "  %s\n", buf);
  displayBest (conqfile, loser, KWINNER);
  pmessage ("***********************************************************",
	    0, MALL | MCONQ, "");
  fprintf (conqfile, "\n\n");

  fclose (conqfile);
}

typedef struct playerlist
{
  struct player *p;
  int w;
}
Players;

displayBest (conqfile, team, type)
     FILE *conqfile;
     int team, type;
{
  register int i, k, l;
  register struct player *j;
  int planets, armies;
  Players winners[MAXPLAYER + 1];
  char buf[80];
  int number;
  int w;

  number = 0;
  for (i = 0, j = &players[0]; i < MAXPLAYER; i++, j++)
    {
      if (j->p_team != team || j->p_status == PFREE)
	continue;

      /* hmmf, the formula which presumes to do too much.
         ** Since I'm not a total moron, I'll just leave it the way it has
         ** always been.
       */
      /*w = 30 * j->p_stats.st_tplanets + j->p_stats.st_tarmsbomb; */

      /* ok, I'm a moron, I can't resist adding a few more factors */
      w = 20 * j->p_stats.st_tplanets
	+ j->p_stats.st_tarmsbomb
	+ 10 * j->p_stats.st_tpd
	+ 5 * j->p_stats.st_tarmsogged
	- 10 * j->p_stats.st_tfarmsogged;	/* twink */

      for (k = 0; k < number; k++)
	{
	  if (winners[k].w < w)
	    {
	      /* insert person at location k */
	      break;
	    }
	}
      for (l = number; l >= k; l--)
	{
	  winners[l + 1] = winners[l];
	}
      number++;
      winners[k].w = w;
      winners[k].p = j;
    }

  sprintf (buf, "  Player name            tpt tpd tab tac cak fao eao  ticks");
  pmessage (buf, 0, MALL | MCONQ, "");
  fprintf (conqfile, "  %s\n", buf);

  for (k = 0; k < number; k++)
    {

      j = winners[k].p;

      if (j->p_stats.st_tticks < 2)
	continue;

      /* basically, simple pwstats here... */
      /* there is no reason why we can't do all the pw processing here. */

      sprintf (buf, "  %16s (%2.2s)  %3d %3d %3d %3d %3d %3d %3d %6d",
	       j->p_name,
	       j->p_mapchars,
	       j->p_stats.st_tplanets,
	       j->p_stats.st_tpd,
	       j->p_stats.st_tarmsbomb,
	       j->p_stats.st_tarmscar,
	       j->p_stats.st_tcarmsdied,
	       j->p_stats.st_tfarmsogged,
	       j->p_stats.st_tarmsogged,
	       j->p_stats.st_tticks);

      pmessage (buf, 0, MALL | MCONQ, "");
      fprintf (conqfile, "  %s\n", buf);
    }
  return;
}

/* XXX Gag me! */
/* the four close planets to the home planet */
static int core_planets[4][4] =
{
  {7, 9, 5, 8,},
  {12, 19, 15, 16,},
  {24, 29, 25, 26,},
  {34, 39, 38, 37,},
};
/* the outside edge, going around in order */
static int front_planets[4][5] =
{
  {1, 2, 4, 6, 3,},
  {14, 18, 13, 17, 11,},
  {22, 28, 23, 21, 27,},
  {31, 32, 33, 35, 36,},
};

void 
doResources (startup)
     int startup;
{
  int i, j, k, which;

  /* this is all over the fucking place :-) */
  for (i = 0; i <= MAXTEAM; i++)
    {
      teams[i].s_turns = 0;
    }

  if (startup)
    {
      bcopy (pdata, planets, sizeof (pdata));

      for (i = 0; i < MAXPLANETS; i++)
	{
	  planets[i].pl_info = ALLTEAM;
	}

      for (i = 0; i < 4; i++)
	{
	  /* one core AGRI */
	  planets[core_planets[i][rrandom () % 4]].pl_flags |= PLAGRI;

	  /* one front AGRI */
	  which = rrandom () % 2;
	  if (which)
	    {
	      j = random () % 2;
	      planets[front_planets[i][j]].pl_flags |= PLAGRI;

	      /* give fuel to planet next to agri (hde) */
	      planets[front_planets[i][!j]].pl_flags |= PLFUEL;

	      /* place one repair on the other front */
	      planets[front_planets[i][(rrandom () % 3) + 2]].pl_flags |= PLREPAIR;

	      /* place 2 FUEL on the other front */
	      for (j = 0; j < 2; j++)
		{
		  do
		    {
		      k = rrandom () % 3;
		    }
		  while (planets[front_planets[i][k + 2]].pl_flags & PLFUEL);
		  planets[front_planets[i][k + 2]].pl_flags |= PLFUEL;
		}
	    }
	  else
	    {
	      j = random () % 2;
	      planets[front_planets[i][j + 3]].pl_flags |= PLAGRI;
	      /* give fuel to planet next to agri (hde) */
	      planets[front_planets[i][(!j) + 3]].pl_flags |= PLFUEL;

	      /* place one repair on the other front */
	      planets[front_planets[i][rrandom () % 3]].pl_flags |= PLREPAIR;

	      /* place 2 FUEL on the other front */
	      for (j = 0; j < 2; j++)
		{
		  do
		    {
		      k = rrandom () % 3;
		    }
		  while (planets[front_planets[i][k]].pl_flags & PLFUEL);
		  planets[front_planets[i][k]].pl_flags |= PLFUEL;
		}
	    }

	  /* drop one more repair in the core (home + 1 front + 1 core = 3 Repair) */
	  planets[core_planets[i][rrandom () % 4]].pl_flags |= PLREPAIR;

	  /* now we need to put down 2 fuel (home + 2 front + 2 = 5 fuel) */
	  for (j = 0; j < 2; j++)
	    {
	      do
		{
		  k = rrandom () % 4;
		}
	      while (planets[core_planets[i][k]].pl_flags & PLFUEL);
	      planets[core_planets[i][k]].pl_flags |= PLFUEL;
	    }
	}
    }
  else
    {
      for (i = 0; i < MAXPLANETS; i++)
	{
	  planets[i].pl_info = pdata[i].pl_info;
	  planets[i].pl_owner = pdata[i].pl_owner;
	  planets[i].pl_armies = *initial_armies;
	}
    }
  RandomizePopOrder ();
}

static FILE *INL_msgfp = NULL;
log_inl_message (str)
     char *str;
{
  if (INL_msgfp == NULL)
    {
      INL_msgfp = fopen (INL_LOGFILE, "a");
    }
  if (INL_msgfp != NULL)
    {
      fputs (str, INL_msgfp);
    }
}

close_inl_messagelog ()
{
  if (INL_msgfp != NULL)
    {
      fclose (INL_msgfp);
      INL_msgfp = NULL;
    }

}

/* periodically run this, log all the messages 
   ** 
 */
Log_Messages ()
{
  static int oldmctl = 0;
  struct timeval tv;		/* ***BAV*** */
  struct tm *tp;		/* ***BAV*** */
  char *ap;			/* ***BAV*** */
  char tc[256];			/* ***BAV*** */
  char buf[80];
  struct distress dist;
  long ttime;

  /* Begin ***BAV*** addition */
  if (oldmctl == mctl->mc_current)
    return;
  gettimeofday (&tv, (struct timezone *) 0);
  if (status->tourn)
    {
      tv.tv_sec -= start_Tourn_sec;
      tp = gmtime (&tv.tv_sec);
    }				/* just give delta time in tmode */
  else
    {
      tp = localtime (&tv.tv_sec);	/* Could use localtime() instead */
    }
  ap = asctime (tp);		/* Maybe should copy contents of *ap elsewhere */

  while (oldmctl != mctl->mc_current)
    {
      if (!status->tourn)
	{
	  strncpy (tc, ap + 4, 15);
	  *(tc + 15) = ' ';
	  *(tc + 16) = '\0';
	}
      else
	{
	  strncpy (tc, ap + 12, 7);
	  *(tc + 7) = '\0';
	  strcat (tc, ":T \0");
	}
      oldmctl++;
      if (oldmctl == 50)
	oldmctl = 0;
      if ( messages[oldmctl].m_flags == ( MDISTR | MTEAM | MVALID ) ) {
         HandleGenDistr(messages[oldmctl].m_data,messages[oldmctl].m_from,0,&dist);
         makedistress(&dist,buf,distmacro[dist.distype].macro);
	 strncat(tc, buf,80);
	 strcat(tc,"\n");
      }
      else {
         strncat (tc, messages[oldmctl].m_data, 150);	/* ***BAV*** */
         strcat (tc, "\n");	/* ***BAV*** */
      }
      log_inl_message (tc);
    }
}

/* handle pausing and such.
   **
   ** Meant to be run only once per update from move()
   **
   ** return 0 if game not paused
   ** return 1 if game is paused
 */
int 
Game_Paused ()
{
  int i;
  char buf[80];
  static int paused = 0;	/* note... this baby conveniently counts number
				   of ticks we're paused - jmn */
  static int toreqtime = 0;	/* count how long timeoutreq is pending */
  static char treq = 0;
  static char whypause = 0;	/* 1 for pause 2 for timeout */

#ifdef ONE_CAPTAINS_TO_PAUSE
  /* not needed now that we have PAUSENOW */
  if (pausereq[0])
    {
      pausereq[1] = 1;
    }
  if (pausereq[1])
    {
      pausereq[0] = 1;
    }
#endif

  treq = (timeoutreq[0] | timeoutreq[1]) & 0x80;

  if (paused == 0)
    {
      if (treq != 0)
	toreqtime++;
      if ((pausereq[0] && pausereq[1]) ||
	  (TimeoutStatus == 0 && (pausereq[0] || pausereq[1])) ||
	  ((treq != 0) &&
	   (TimeoutStatus == 0 ||
      /* linear decrease in timeoutrequest strictness from 1.4*yellow
         to yellow at 100sec mark and then down */
      (pdistmin > ((14000.0 - toreqtime * 4) * YRANGE * YRANGE) / 10000.0))))
	{
	  paused = 1;
	  whypause = (treq != 0) ? 2 : 1;
	  timeoutreq[0] &= 0x7f;	/* reset the request bit */
	  timeoutreq[1] &= 0x7f;
	  /* kludge to set pausereq to 1 if we are paused */
	  pausereq[0] = 1;
	  pausereq[1] = 1;
#ifdef SHORT_PACKETS
	  arg[0] = INLDTEXTE;
	  arg[1] = 0;
#endif
	  pmessage ("Game is paused.  CONTINUE to continue.", 0, MALL, "");
	  for (i = 0; i < MAXPLAYER; i++)
	    players[i].p_flags &= ~PFSEEN;
	}

    }
  else
    {				/* paused !=0 */
      paused++;
      if (paused < 0)
	{
	  if ((-paused) % 10)
	    return 1;
	  sprintf (buf, "Game will resume in %d seconds", (-paused) / 10);
#ifdef SHORT_PACKETS
	  arg[0] = INLDRESUME;
	  arg[1] = (-paused) / 10;
#endif
	  pmessage (buf, 0, MALL, "");
	  status->gamepaused = paused;
	  /* this will confuse people quitting during the resume countdown */
	  return 1;
	}
      if (paused == 0)
	{
#ifdef SHORT_PACKETS
	  arg[0] = INLDTEXTE;
	  arg[1] = 1;
#endif
	  pmessage ("Game is no-longer paused!",
		    0, MALL, "");
	}
      else
	{
	  if (!(paused % ONE))
#ifdef SHORT_PACKETS
	    {
	      arg[0] = INLDTEXTE;
	      arg[1] = 2;
	      pmessage ("Game is paused. Captains CONTINUE to continue.",
			0, MALL, "");
	    }
#else
	    pmessage ("Game is paused. Captains CONTINUE to continue.",
		      0, MALL, "");
#endif
	}

      if ((continuereq[0] && continuereq[1]) ||
	((paused > to_len * 600) && (whypause == 2)) || (paused > 20 * 600))
	{
	  paused = -100;
	  toreqtime = 0;
	  pausereq[0] = pausereq[1] = 0;
	  continuereq[0] = continuereq[1] = 0;
#ifdef SHORT_PACKETS
	  arg[0] = INLDTEXTE;
	  arg[1] = 3;
#endif
	  pmessage ("Game will continue in 10 seconds", 0, MALL, "");
	}
    }

  status->gamepaused = paused;

  if (paused)
    {
      PauseGhostbuster ();
      return 1;
    }
  else
    {
      return 0;
    }
}

/* update ghostbuster timers during pauses */
PauseGhostbuster ()
{
  struct player *j;
  int i;
  for (i = 0; i < MAXPLAYER; i++)
    {
      j = &players[i];
      if (j->p_status == PFREE)
	{
	  j->p_ghostbuster = 0;	/* was == */
	  continue;
	}
      if (++(j->p_ghostbuster) > GHOSTTIME)
	{
	  switch (j->p_status)
	    {
	    case PALIVE:
	      j->p_status = PDEAD;
	      ghostmess (j);
	      saveplayer (j);
	      j->p_whydead = KGHOST;
	      j->p_whodead = i;
	      break;
	    case PEXPLODE:
	    case POBSERV:
	      j->p_status = PDEAD;
	      j->p_armies = 0;	/* hack-  coaches can't carry armies */
	      ghostmess (j);
	      saveplayer (j);
	      j->p_whydead = KGHOST;
	      j->p_whodead = i;
	      break;
	    case PDEAD:
	      j->p_status = POUTFIT;
	      break;
	    case POUTFIT:
	      saveplayer (j);	/* just in case its needed again! */
	      /*
	         Hey, don't do this, it'll let people in off the Q
	         j->p_status = PFREE;
	       */

	      break;
	    default:		/* really weird state! */
	      j->p_status = PFREE;
#ifdef DS
	      if (j->p_process > 1)
		(void) kill (j->p_process, SIGTERM);
#endif

	    }
	  j->p_ghostbuster = 0;
	}
    }
}


/* this should free the linked list of nstats */
reset_new_stats ()
{
  struct st_new_stats *nextNstats;
  struct st_new_stats *oldnextNstats;
  struct planet *l;
  struct player *j;
  int teamno, i;

  if (!nstats)
    return;

  /* yikes!  netrek never uses free() that I can find.. no examples
     ** to work from, hope I use this right...
     ** If all else fails, we can skip this and just return nstats=NULL
   */

  for (nextNstats = First_Nstats; nextNstats;)
    {
      oldnextNstats = nextNstats;
      nextNstats = oldnextNstats->next;
      free (oldnextNstats);
    }

  nstats = NULL;
}

new_stats ()
{
  struct st_new_stats *new_stats;
  struct planet *l;
  struct player *j;
  int teamno, i;

  new_stats = (struct st_new_stats *) malloc (sizeof (struct st_new_stats));
  if (!new_stats)
    {
      /* Tell someone ? */
      nstats = NULL;
      return;
    }

  bzero (new_stats, sizeof (*new_stats));
  new_stats->age = ticks;

  for (i = 0; i <= NUMTEAM; i++)
    new_stats->team[i].plague.low = -1;

  for (i = 0, l = planets + i; i < MAXPLANETS; i++, l++)
    {
      teamno = remap[l->pl_owner];
      if (teamno > 0)
	new_stats->team[teamno].start += l->pl_armies;
    }

  for (i = 0, j = &players[0]; i < MAXPLAYER; i++, j++)
    {
      teamno = remap[j->p_team];
      if (teamno > 0 && j->p_status == PALIVE)
	{
	  new_stats->team[teamno].start += j->p_armies;
	}
    }

  if (INL_period)
    new_stats->period = *INL_period;
  else
    new_stats->period = -1;	/* This shouldn't happen, right? */

  if (INL_tourn_start)
    new_stats->time = (ticks - INL_tourn_start) / 600;
  /* in minutes */
  else
    new_stats->time = -1;	/* dead time, caused by a "restart game" */

  if (nstats)
    nstats->next = new_stats;
  else
    First_Nstats = new_stats;

  nstats = new_stats;
}

save_nstats ()
{
  FILE *sfd;			/* Him again?  ugh */
  int i;
  struct st_new_stats *n;
  struct timeval tv;
  struct tm *tp;
  char starttime[20], endtime[20];
  char *ap;
  long *y;
  long z[sizeof (struct st_new_stats) / sizeof (long)];
  int j;
  long teamno;

  unsigned long byteswapcheck;
  long vers_low;
  long vers_curr;
  long struct_size;

  byteswapcheck = htonl (NSTATS_BYTESWAP_MAGIC);
  vers_low = htonl (NSTATS_COMPAT);
  vers_curr = htonl (NSTATS_VERSION);
  struct_size = htonl (sizeof (struct st_new_stats));

  if (!First_Nstats)
    {
      /* Tell someone ? */
      return;
    }

  sfd = fopen (INL_TIMESTATS, "w");

  if (!sfd)
    {
      /* Bozos!  Tell someone?  popen to mail? open backup stats file? */
      return;
    }

  /* New: header info */
  /* NOTE: If you change the file format, see "newstats.h" for changing
     *       the version numbers
   */

  fprintf (sfd, "Netrek INL timestats, server: v%spl%d\n", mvers, PATCHLEVEL);

  tp = localtime (&start_Tourn_sec);
  ap = asctime (tp);
  strncpy (starttime, ap, 19);
  starttime[19] = '\0';

  gettimeofday (&tv, (struct timezone *) 0);
  tp = localtime (&tv.tv_sec);
  ap = asctime (tp);
  strncpy (endtime, ap, 19);
  endtime[19] = '\0';

  fprintf (sfd, "Game started at %s, game ended at %s\n", starttime, endtime);
  fprintf (sfd, "between \"%s\" (%s) and \"%s\" (%s)\n",
	   teamname[0], teamshort[INLteamschosen[0]],
	   teamname[1], teamshort[INLteamschosen[1]]);

  fprintf (sfd, "The rest of this file is binary data.\n");
  fwrite (&byteswapcheck, sizeof (long), 1, sfd);

  fwrite (&vers_low, sizeof (long), 1, sfd);
  fwrite (&vers_curr, sizeof (long), 1, sfd);
  fwrite (&struct_size, sizeof (long), 1, sfd);
  teamno = remap[INLteamschosen[0]];
  teamno = htonl (teamno);
  fwrite (&teamno, sizeof (long), 1, sfd);
  teamno = remap[INLteamschosen[1]];
  teamno = htonl (teamno);
  fwrite (&teamno, sizeof (long), 1, sfd);

  for (n = First_Nstats; n; n = n->next)
    {
      y = (long *) n;
      for (j = 0; j < sizeof (*n) / sizeof (long); j++)
	z[j] = htonl (y[j]);
      i = fwrite (z, sizeof (*n), 1, sfd);
      if (i != sizeof (n))
	{
	  /* Bitch at someone here!  Maybe do a recursize call, passing
	     in a flag saying to open the stat file in /tmp or something. */
	}
    }

  fclose (sfd);
}

#ifdef DS

/*
 * The minor problem here is that the only client update speeds that
 * make sense are 10, 5, 3, 2, 1.
 */

signal_servers ()
{
  register i, t;
  register struct player *j;
  static int counter;		/* need our own counter */

  counter++;

  for (i = 0, j = players; i < MAXPLAYER; i++, j++)
    {
      if (!j->p_status)
	continue;
      if (j->p_process <= 1)
	continue;

      t = j->p_timerdelay;
      if (!t)			/* paranoia */
	t = 5;

      /* adding 'i' to 'counter' allows us to "interleave" update signals to
         the ntserv processes: at 5 u/s, 1/2 the processes are signalled on
         every update, at 2 u/s, 1/5 are signalled, etc.  (Of course, if
         everyone is at 10 u/s we have to signal them all every time) */

      if (t == 1 /*skip mod */  || (((counter + i) % t) == 0))
	{
	  if (kill (j->p_process, SIGALRM) < 0)
	    {
	      /* if the ntserv process died what are we doing here? */
	      if (errno == ESRCH)
		j->p_status = PFREE;
	    }
	}
    }
}

#endif
