/*
 * getship.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

/* fill in ship characteristics */

getship (shipp, s_type)
     struct ship *shipp;
     int s_type;
{
  register i = 0;

  switch (s_type)
    {
    case SCOUT:
      shipp->s_turns = 570000;	/* scout */
      shipp->s_accint = 200;	/* scout: was 185 */
      shipp->s_decint = 270;	/* scout: was 270 */
      shipp->s_accs = 100;	/* scout:  */
      shipp->s_torpdamage = 25;	/* scout: was 25 */
      shipp->s_plasmadamage = -1;	/* scout:  */
      shipp->s_phaserfuse = 10;	/* scout:  */
      shipp->s_phaserdamage = 75;	/* scout: was 75 */
      shipp->s_torpspeed = 16;	/* scout: was 16 */
      shipp->s_torpfuse = 16;	/* scout:  */
      shipp->s_torpturns = 0;	/* scout:  */
      shipp->s_plasmaspeed = 0;	/* scout:  */
      shipp->s_plasmafuse = 0;	/* scout:  */
      shipp->s_plasmaturns = 0;	/* scout:  */
      shipp->s_maxspeed = 12;	/* scout:  */
      shipp->s_repair = 80;	/* scout:  */
      shipp->s_maxfuel = 5000;	/* scout:  */
      shipp->s_detcost = 100;	/* scout:  */
      shipp->s_torpcost = 7 * shipp->s_torpdamage;	/* scout:  */
      shipp->s_plasmacost = 20 * shipp->s_plasmadamage;		/* scout:  */
      shipp->s_phasercost = 7 * shipp->s_phaserdamage;	/* scout:  */
      shipp->s_warpcost = 2;	/* scout:  */
      shipp->s_cloakcost = 17;	/* scout:  */
      shipp->s_recharge = 8;	/* scout:  */
      shipp->s_maxarmies = 2;	/* scout:  */
      shipp->s_maxshield = 75;	/* scout: was 75 */
      shipp->s_maxdamage = 75;	/* scout:  */
      shipp->s_wpncoolrate = 3;	/* scout:  */
      shipp->s_egncoolrate = 8;	/* scout:  */
      shipp->s_maxwpntemp = 1000;	/* scout:  */
      shipp->s_maxegntemp = 1000;	/* scout:  */
      shipp->s_type = SCOUT;	/* scout:  */
      shipp->s_mass = 1500;	/* scout:  */
      shipp->s_tractstr = 2000;	/* scout:  */
      shipp->s_tractrng = .7;	/* scout:  */
      shipp->s_width = 20;	/* scout:  */
      shipp->s_height = 20;	/* scout:  */
      break;
    case DESTROYER:
      shipp->s_turns = 310000;	/* destroyer: */
      shipp->s_accint = 200;	/* destroyer: */
      shipp->s_decint = 300;	/* destroyer: */
      shipp->s_accs = 100;	/* destroyer: */
      shipp->s_torpdamage = 30;	/* destroyer: */
      shipp->s_plasmadamage = 75;	/* destroyer: */
      shipp->s_phaserfuse = 10;	/* destroyer: */
      shipp->s_phaserdamage = 85;	/* destroyer: */
      shipp->s_torpspeed = 14;	/* destroyer: */
      shipp->s_torpfuse = 30;	/* destroyer: */
      shipp->s_torpturns = 0;	/* destroyer: */
      shipp->s_plasmaspeed = 15;	/* destroyer: */
      shipp->s_plasmafuse = 30;	/* destroyer: */
      shipp->s_plasmaturns = 1;	/* destroyer: */
      shipp->s_maxspeed = 10;	/* destroyer: */
      shipp->s_repair = 100;	/* destroyer: */
      shipp->s_maxfuel = 7000;	/* destroyer: */
      shipp->s_detcost = 100;	/* destroyer: */
      shipp->s_torpcost = 7 * shipp->s_torpdamage;	/* destroyer: */
      shipp->s_plasmacost = 30 * shipp->s_plasmadamage;		/* destroyer: */
      shipp->s_phasercost = 7 * shipp->s_phaserdamage;	/* destroyer: */
      shipp->s_warpcost = 3;	/* destroyer: */
      shipp->s_cloakcost = 21;	/* destroyer: */
      shipp->s_recharge = 11;	/* destroyer: */
      shipp->s_maxarmies = 5;	/* destroyer: */
      shipp->s_maxshield = 85;	/* destroyer: */
      shipp->s_maxdamage = 85;	/* destroyer: */
      shipp->s_wpncoolrate = 2;	/* destroyer: */
      shipp->s_egncoolrate = 7;	/* destroyer: */
      shipp->s_maxwpntemp = 1000;	/* destroyer: */
      shipp->s_maxegntemp = 1000;	/* destroyer: */
      shipp->s_mass = 1800;	/* destroyer: */
      shipp->s_tractstr = 2500;	/* destroyer: */
      shipp->s_tractrng = .9;	/* destroyer: */
      shipp->s_width = 20;	/* destroyer: */
      shipp->s_height = 20;	/* destroyer: */
      shipp->s_type = DESTROYER;	/* destroyer: */
      break;
    case BATTLESHIP:
      shipp->s_turns = 75000;	/* battleship: */
      shipp->s_accint = 80;	/* battleship: */
      shipp->s_decint = 180;	/* battleship: */
      shipp->s_accs = 100;	/* battleship: */
      shipp->s_torpdamage = 40;	/* battleship: */
      shipp->s_plasmadamage = 130;	/* battleship: */
      shipp->s_phaserfuse = 10;	/* battleship: */
      shipp->s_phaserdamage = 105;	/* battleship: */
      shipp->s_torpspeed = 12;	/* battleship: */
      shipp->s_torpfuse = 40;	/* battleship: */
      shipp->s_torpturns = 0;	/* battleship: */
      shipp->s_plasmaspeed = 15;	/* battleship: */
      shipp->s_plasmafuse = 35;	/* battleship: */
      shipp->s_plasmaturns = 1;	/* battleship: */
      shipp->s_maxspeed = 8;	/* battleship: */
      shipp->s_repair = 125;	/* battleship: */
      shipp->s_maxfuel = 14000;	/* battleship: */
      shipp->s_detcost = 100;	/* battleship: */
      shipp->s_torpcost = 9 * shipp->s_torpdamage;	/* battleship: */
      shipp->s_plasmacost = 30 * shipp->s_plasmadamage;		/* battleship: */
#ifdef NEWSHIP
      shipp->s_phasercost = 9 * shipp->s_phaserdamage;	/* battleship: */
#else
      shipp->s_phasercost = 10 * shipp->s_phaserdamage;		/* battleship: */
#endif
      shipp->s_warpcost = 6;	/* battleship: */
      shipp->s_cloakcost = 30;	/* battleship: */
      shipp->s_recharge = 14;	/* battleship: */
      shipp->s_maxarmies = 6;	/* battleship: */
      shipp->s_maxshield = 130;	/* battleship: */
      shipp->s_maxdamage = 130;	/* battleship: */
      shipp->s_wpncoolrate = 3;	/* battleship: */
      shipp->s_egncoolrate = 6;	/* battleship: */
      shipp->s_maxwpntemp = 1000;	/* battleship: */
      shipp->s_maxegntemp = 1000;	/* battleship: */
      shipp->s_mass = 2300;	/* battleship: */
      shipp->s_tractstr = 3700;	/* battleship: */
      shipp->s_tractrng = 1.2;	/* battleship: */
      shipp->s_width = 20;	/* battleship: */
      shipp->s_height = 20;	/* battleship: */
      shipp->s_type = BATTLESHIP;	/* battleship: */
      break;
    case ASSAULT:
      shipp->s_turns = 120000;	/* assault */
      shipp->s_accint = 100;	/* assault */
      shipp->s_decint = 200;	/* assault */
      shipp->s_accs = 100;	/* assault */
      shipp->s_torpdamage = 30;	/* assault */
      shipp->s_plasmadamage = -1;	/* assault */
      shipp->s_phaserfuse = 10;	/* assault */
      shipp->s_phaserdamage = 80;	/* assault */
      shipp->s_torpspeed = 16;	/* assault */
      shipp->s_torpfuse = 30;	/* assault */
      shipp->s_torpturns = 0;	/* assault */
      shipp->s_plasmaspeed = 0;	/* assault */
      shipp->s_plasmafuse = 0;	/* assault */
      shipp->s_plasmaturns = 0;	/* assault */
      shipp->s_maxspeed = 8;	/* assault */
      shipp->s_repair = 120;	/* assault */
      shipp->s_maxfuel = 6000;	/* assault */
      shipp->s_detcost = 100;	/* assault */
#ifdef NEWSHIP
      shipp->s_torpcost = 7 * shipp->s_torpdamage;	/* assault */
#else
      shipp->s_torpcost = 9 * shipp->s_torpdamage;	/* assault */
#endif
      shipp->s_plasmacost = 20 * shipp->s_plasmadamage;		/* assault */
      shipp->s_phasercost = 7 * shipp->s_phaserdamage;	/* assault */
      shipp->s_warpcost = 3;	/* assault */
      shipp->s_cloakcost = 17;	/* assault */
      shipp->s_recharge = 10;	/* assault */
      shipp->s_maxarmies = 20;	/* assault */
      shipp->s_maxshield = 80;	/* assault */
      shipp->s_maxdamage = 200;	/* assault */
      shipp->s_wpncoolrate = 2;	/* assault */
      shipp->s_egncoolrate = 6;	/* assault */
      shipp->s_maxwpntemp = 1000;	/* assault */
      shipp->s_maxegntemp = 1200;	/* assault */
      shipp->s_mass = 2300;	/* assault */
      shipp->s_tractstr = 2500;	/* assault */
      shipp->s_tractrng = .7;	/* assault */
      shipp->s_width = 20;	/* assault */
      shipp->s_height = 20;	/* assault */
      shipp->s_type = ASSAULT;	/* assault */
      break;
    case STARBASE:
      shipp->s_turns = 50000;	/* starbase */
      shipp->s_accint = 100;	/* starbase */
      shipp->s_decint = 200;	/* starbase */
      shipp->s_accs = 100;	/* starbase */
      shipp->s_torpdamage = 30;	/* starbase */
      shipp->s_plasmadamage = 150;	/* starbase */
      shipp->s_phaserfuse = 4;	/* starbase */
      shipp->s_phaserdamage = 120;	/* starbase */
      shipp->s_torpspeed = 14;	/* starbase */
      shipp->s_torpfuse = 30;	/* starbase */
      shipp->s_torpturns = 0;	/* starbase */
      shipp->s_plasmaspeed = 15;	/* starbase */
      shipp->s_plasmafuse = 25;	/* starbase */
      shipp->s_plasmaturns = 1;	/* starbase */
      shipp->s_repair = 140;	/* starbase */
      shipp->s_maxfuel = 60000;	/* starbase */
      shipp->s_detcost = 100;	/* starbase */
      shipp->s_torpcost = 10 * shipp->s_torpdamage;	/* starbase */
      shipp->s_plasmacost = 25 * shipp->s_plasmadamage;		/* starbase */
      shipp->s_phasercost = 8 * shipp->s_phaserdamage;	/* starbase */
      shipp->s_warpcost = 10;	/* starbase */
      shipp->s_cloakcost = 75;	/* starbase */
      shipp->s_recharge = 35;	/* starbase */
      shipp->s_maxarmies = 25;	/* starbase */
      shipp->s_maxshield = 500;	/* starbase */
      shipp->s_maxdamage = 600;	/* starbase */
      shipp->s_wpncoolrate = 4;	/* starbase */
      shipp->s_egncoolrate = 4;	/* starbase */
      if (!chaos)
	{
	  shipp->s_maxspeed = 2;	/* starbase */
#ifdef NEWSHIP
	  shipp->s_maxwpntemp = 1500;	/* starbase */
#else
	  shipp->s_maxwpntemp = 1300;	/* starbase */
#endif
	  shipp->s_maxegntemp = 1000;	/* starbase */
	}
      else
	{
	  shipp->s_maxspeed = 3;	/* starbase */
	  shipp->s_maxwpntemp = 999999;		/* starbase */
	  shipp->s_maxegntemp = 999999;		/* starbase */
	}
      shipp->s_mass = 5000;	/* starbase */
      shipp->s_tractstr = 8000;	/* starbase */
      shipp->s_tractrng = 1.5;	/* starbase */
      shipp->s_width = 20;	/* starbase */
      shipp->s_height = 20;	/* starbase */
      shipp->s_type = STARBASE;	/* starbase */
      break;
    case ATT:
      shipp->s_turns = 2140000000;	/* att: */
      shipp->s_accint = 3000;	/* att: */
      shipp->s_decint = 3000;	/* att: */
      shipp->s_accs = 100;	/* att: */
      shipp->s_torpdamage = 1000;	/* att: */
      shipp->s_plasmadamage = 1000;	/* att: */
      shipp->s_phaserfuse = 2;	/* att: */
      shipp->s_phaserdamage = 10000;	/* att: */
      shipp->s_torpspeed = 30;	/* att: */
      shipp->s_torpfuse = 200;	/* att: */
      shipp->s_torpturns = 10;	/* att: */
      shipp->s_plasmaspeed = 45;	/* att: */
      shipp->s_plasmafuse = 10000;	/* att: */
      shipp->s_plasmaturns = 14;	/* att: */
      shipp->s_maxspeed = 60;	/* att: */
      shipp->s_repair = 30000;	/* att: */
      shipp->s_maxfuel = 60000;	/* att: */
      shipp->s_detcost = 1;	/* att: */
      shipp->s_torpcost = 1;	/* att: */
      shipp->s_plasmacost = 1;	/* att: */
      shipp->s_phasercost = 1;	/* att: */
      shipp->s_warpcost = 1;	/* att: */
      shipp->s_cloakcost = 1;	/* att: */
      shipp->s_recharge = 1000;	/* att: */
      shipp->s_maxarmies = 1000;	/* att: */
      shipp->s_maxshield = 30000;	/* att: */
      shipp->s_maxdamage = 30000;	/* att: */
      shipp->s_wpncoolrate = 100;	/* att: */
      shipp->s_egncoolrate = 100;	/* att: */
      shipp->s_maxwpntemp = 10000;	/* att: */
      shipp->s_maxegntemp = 10000;	/* att: */
      shipp->s_mass = 32765;	/* att: */
      shipp->s_tractstr = 32765;	/* att: */
      shipp->s_tractrng = 25;	/* att: */
      shipp->s_width = 28;	/* att: */
      shipp->s_height = 28;	/* att: */
      shipp->s_type = ATT;	/* att: */
      break;
    default:
      shipp->s_turns = 170000;	/* cruiser: */
      shipp->s_accint = 150;	/* cruiser: */
      shipp->s_decint = 200;	/* cruiser: */
      shipp->s_accs = 100;	/* cruiser: */
      shipp->s_torpdamage = 40;	/* cruiser: */
      shipp->s_plasmadamage = 100;	/* cruiser: */
      shipp->s_phaserfuse = 10;	/* cruiser: */
      shipp->s_phaserdamage = 100;	/* cruiser: */
      shipp->s_torpspeed = 12;	/* cruiser: */
      shipp->s_torpfuse = 40;	/* cruiser: */
      shipp->s_torpturns = 0;	/* cruiser: */
      shipp->s_plasmaspeed = 15;	/* cruiser: */
      shipp->s_plasmafuse = 35;	/* cruiser: */
      shipp->s_plasmaturns = 1;	/* cruiser: */
      shipp->s_maxspeed = 9;	/* cruiser: */
      shipp->s_repair = 110;	/* cruiser: */
      shipp->s_maxfuel = 10000;	/* cruiser: */
      shipp->s_detcost = 100;	/* cruiser: */
      shipp->s_torpcost = 7 * shipp->s_torpdamage;	/* cruiser: */
      shipp->s_plasmacost = 30 * shipp->s_plasmadamage;		/* cruiser: */
      shipp->s_phasercost = 7 * shipp->s_phaserdamage;	/* cruiser: */
      shipp->s_warpcost = 4;	/* cruiser: */
      shipp->s_cloakcost = 26;	/* cruiser: */
      shipp->s_recharge = 12;	/* cruiser: */
      shipp->s_maxarmies = 10;	/* cruiser: */
      shipp->s_maxshield = 100;	/* cruiser: */
      shipp->s_maxdamage = 100;	/* cruiser: */
      shipp->s_wpncoolrate = 2;	/* cruiser: */
      shipp->s_egncoolrate = 6;	/* cruiser: */
      shipp->s_maxwpntemp = 1000;	/* cruiser: */
      shipp->s_maxegntemp = 1000;	/* cruiser: */
      shipp->s_mass = 2000;	/* cruiser: */
      shipp->s_tractstr = 3000;	/* cruiser: */
      shipp->s_tractrng = 1.0;	/* cruiser: */
      shipp->s_width = 20;	/* cruiser: */
      shipp->s_height = 20;	/* cruiser: */
      shipp->s_type = CRUISER;	/* cruiser: */
      break;
    }
}
