/*
 * phaser.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

phaser (course)
     unsigned char course;
{
  register int i;
  register struct player *j, *target;
  register struct plasmatorp *target2;
  register struct plasmatorp *k;
  register struct phaser *mine;
  int whichtarget;
  int target_x, target_y;
  unsigned char dir;
  int range, trange;
  int maxangle;
  int myphrange;
  char buf[80];

  mine = &phasers[me->p_no];

  if (myship->s_phasercost < 0)
    {
#ifdef SHORT_PACKETS
      spwarning ("Weapons Officer:  This ship is not armed with phasers, captain!", 31);
#else
      warning ("Weapons Officer:  This ship is not armed with phasers, captain!");
#endif
      return;
    }
  if (mine->ph_status != PHFREE)
    {
#ifdef SHORT_PACKETS
      spwarning ("Phasers have not recharged", 32);
#else
      warning ("Phasers have not recharged");
#endif
#ifdef BD
      if(mine->ph_status == PHHIT2 || mine->ph_status == PHHIT)
         bd_phaser(course);
#endif
      return;
    }
  if (me->p_fuel < myship->s_phasercost)
    {
#ifdef SHORT_PACKETS
      spwarning ("Not enough fuel for phaser", 33);
#else
      warning ("Not enough fuel for phaser");
#endif
      return;
    }
  if (me->p_flags & PFREPAIR)
    {
#ifdef SHORT_PACKETS
      spwarning ("Can't fire while repairing", 34);
#else
      warning ("Can't fire while repairing");
#endif
      return;
    }
  if (me->p_flags & PFWEP)
    {
#ifdef SHORT_PACKETS
      spwarning ("Weapons overheated", 35);
#else
      warning ("Weapons overheated");
#endif
      return;
    }
  if ((me->p_cloakphase) && (me->p_ship.s_type != ATT))
    {
#ifdef SHORT_PACKETS
      spwarning ("Cannot fire while cloaked", 36);
#else
      warning ("Cannot fire while cloaked");
#endif
      return;
    }

  me->p_fuel -= myship->s_phasercost;
  me->p_wtemp += myship->s_phasercost / 10;
  mine->ph_dir = course;

  whichtarget = 0;
  range = 1000000;		/* Sufficiently big. */

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if ((j->p_status != PALIVE) || (j == me))
	continue;
      if ((!((j->p_swar | j->p_hostile) & me->p_team)) &&
	  (!((me->p_swar | me->p_hostile) & j->p_team)))
	continue;
      dir = (unsigned char) (atan2 ((double) (j->p_x - me->p_x),
			     (double) (me->p_y - j->p_y)) / 3.14159 * 128.);
      trange = (int) hypot ((double) (j->p_x - me->p_x),
			    (double) (j->p_y - me->p_y));
      if (trange == 0)
	trange = 1;
      maxangle = atan ((float) EXPDIST / trange) / 3.14159 * 128.0;
      if (angdist (dir, course) <= maxangle)
	{
	  if (range > trange)
	    {
	      whichtarget = 1;
	      target = j;
	      range = trange;
	    }
	}
    }

  for (i = 0, k = &plasmatorps[i]; i < MAXPLASMA * MAXPLAYER; i++, k++)
    {
      if ((k->pt_status != PTMOVE) || (k->pt_owner == me->p_no))
	continue;
      if ((!(k->pt_war & me->p_team)) &&
	  (!((me->p_swar | me->p_hostile) & k->pt_team)))
	continue;
      dir = (unsigned char) (atan2 ((double) (k->pt_x - me->p_x),
			    (double) (me->p_y - k->pt_y)) / 3.14159 * 128.);
      trange = (int) hypot ((double) (k->pt_x - me->p_x),
			    (double) (k->pt_y - me->p_y));
      if (trange == 0)
	trange = 1;
      maxangle = atan ((float) EXPDIST / 4 / trange) / 3.14159 * 128.0;
      if (angdist (dir, course) <= (maxangle + 1))
	{
	  if (range > trange)
	    {
	      target_x = k->pt_x;
	      target_y = k->pt_y;
	      whichtarget = 2;
	      target2 = k;
	      range = trange;
	    }
	}
    }

  mine->ph_fuse = me->p_ship.s_phaserfuse;

  myphrange = PHASEDIST * me->p_ship.s_phaserdamage / 100;

  if ((whichtarget == 0) ||
      (range > myphrange))
    {
      mine->ph_status = PHMISS;
#ifdef SHORT_PACKETS
      spwarning ("Phaser missed!!!", 37);
#else
      warning ("Phaser missed!!!");
#endif
    }
  else if (whichtarget == 2)
    {
#ifdef SHORT_PACKETS
      spwarning ("You destroyed the plasma torpedo!", 38);
#else
      warning ("You destroyed the plasma torpedo!");
#endif
      mine->ph_x = target_x;
      mine->ph_y = target_y;
      mine->ph_status = PHHIT2;
      target2->pt_status = PTDET;
    }
  else
    {
      mine->ph_target = target->p_no;
      mine->ph_damage = me->p_ship.s_phaserdamage *
	(1.0 - (range / (float) myphrange));
      if (mine->ph_damage < 0)
	mine->ph_damage = -mine->ph_damage;
      mine->ph_status = PHHIT;
      (void) sprintf (buf, "Phaser burst hit %s for %d points",
		      target->p_name,
		      mine->ph_damage);
#ifdef SHORT_PACKETS
      if (send_short && target->p_no < 64 && mine->ph_damage < 1000)
	{
	  swarn (PHASER_HIT_TEXT, (target->p_no & 0x3f) | ((unsigned) (mine->ph_damage & 768) >> 2), (unsigned char) mine->ph_damage & 0xff);
	}
      else
#endif
	warning (buf);
    }
#ifdef BD
   if(mine->ph_status == PHHIT2 || mine->ph_status == PHHIT)
      bd_phaser(course);
#endif
}
