#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

extern int clue;

static char hours[7][24];
static time_t hr_loaded = 0;

/* NBT - I didn't like the old way this was done so I rewrote it. It now
 *     checks a file that has a entry for every hour of every day.
 It also allows for clue code checking.
 X = not playable
 C = clue hour
 anything else = playable
 * returns a 1 if the time is acceptable for play, 0 otherwise
 */
int 
time_access ()
{
  struct tm *tm;
  time_t secs;
  FILE *tfd;
  int day;
  struct stat tstat;

  time (&secs);
  tm = localtime (&secs);

  if (stat (TIME_FILE, &tstat) != 0)
    return 0;

  if (tstat.st_mtime > hr_loaded)
    {
      hr_loaded = tstat.st_mtime;

      tfd = fopen (TIME_FILE, "r");

      for (day = 0; day <= 6; day++)
	{
	  fscanf (tfd, "%s", hours[day]);
	}

      fclose (tfd);
    }

  /* let one or two players in but no more during off hours */
  if (hours[tm->tm_wday][tm->tm_hour] == 'X' && 
	((realNumShips (INLteams[0]) > 1) || (realNumShips (INLteams[1]) > 1)))
    return 0;
  else
    return 1;
}
