/*
 * warning.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

/*
** The warning in text will be printed in the warning window.
** The message will last WARNTIME/10 seconds unless another message
** comes through and overwrites it.
*/

#ifdef SHORT_PACKETS

extern int sizes[];

warning(text)
char *text;
{
    struct warning_spacket warn;

	if(!send_short){
    		warn.type=SP_WARNING;
    		strncpy(warn.mesg, text, 80);
    		warn.mesg[79]='\0';
    		sendClientPacket(&warn);
	}
	else {	/* send it like a CP_S_MESSAGE */
		int size;
  		strncpy(warn.mesg, text, 80);
    		warn.mesg[79]='\0';
		size = strlen(warn.mesg);
		size += 5; /* 1 for '\0', 4 packetheader */
		if((size % 4) != 0)
                        		size += (4 - (size % 4));	
		warn.pad3 = (char) size;
		sizes[SP_S_WARNING] = size;
		warn.type = SP_S_WARNING;
		warn.pad1 = SHORT_WARNING;
		warn.pad2 = 0; 
		sendClientPacket(&warn);
		sizes[SP_S_WARNING] = sizeof(struct warning_s_spacket); /* Back to default */
	}
}

#else

warning(text)
char *text;
{
    struct warning_spacket warn;

    warn.type=SP_WARNING;
    strncpy(warn.mesg, text, 80);
    warn.mesg[79]='\0';
    sendClientPacket(&warn);
}

#endif
