
#include <X11/Xlib.h>
#include <stdio.h>
/*#include "/usr/att/usr/include/string.h" */
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/ipc.h>
/*#include "/usr/att/usr/include/sys/shm.h" */
#include <math.h>
#include <sys/file.h>
#include <errno.h>
#include <pwd.h>
#include <ctype.h>
#include "defs.h"
#include "struct.h"

struct player *players;
struct player *me;
struct torp *torps;
struct ship *myship;
struct stats *mystats;
struct planet *planets;
struct phaser *phasers;
struct message *messages;
struct mctl *mctl;
struct team *teams;

/* if you play with planet layouts this is handy to use for cut and paste
   into planets.h file - jmn */
openmem ()
{
  extern int errno;
  int shmemKey = PKEY;
  int shmid;
  struct memory *sharedMemory;

  errno = 0;
  shmid = shmget (shmemKey, 0, 0);
  if (shmid < 0)
    {
      if (errno != ENOENT)
	{
	  perror ("shmget");
	  exit (1);
	}
      shmid = shmget (shmemKey, 0, 0);
      if (shmid < 0)
	{
	  fprintf (stderr, "Daemon not running\n");
	  exit (1);
	}
    }
  sharedMemory = (struct memory *) shmat (shmid, 0, 0);
  if (sharedMemory == (struct memory *) -1)
    {
      perror ("shared memory");
      exit (1);
    }
  players = sharedMemory->players;
  torps = sharedMemory->torps;
  planets = sharedMemory->planets;
  phasers = sharedMemory->phasers;
  mctl = sharedMemory->mctl;
  messages = sharedMemory->messages;
  teams = sharedMemory->teams;
}

int theteam[9];
int armies[9];
char *teamchars[] =
{"IND", "FED", "ROM", "X", "KLI", "X", "X", "X", "ORI"};

main (argc, argv)
     int argc;
     char *argv[];
{
  int i, arm;

  if (argc < 2 || atoi (argv[1]) <= 0)
    {
      printf ("Usage: %s armies\n", argv[0]);
      exit (-1);
    }
  arm = atoi (argv[1]);

  openmem ();
  for (i = 0; i < 40; i++)
    {
      printf ("    { %2d, %s%s%s%s, %s, %d, %d, \"%s\", %d, %d, %s },\n",
	      i, teamchars[planets[i].pl_owner],
	      planets[i].pl_flags & PLHOME ? "|PLHOME" : "",
	      planets[i].pl_flags & PLCORE ? "|PLCORE" : "",
	      planets[i].pl_flags & PLHOME ? "|PLREPAIR|PLFUEL" : "",
	      teamchars[planets[i].pl_owner],
	      planets[i].pl_x, planets[i].pl_y,
	      planets[i].pl_name,
	      planets[i].pl_namelen,
	      arm,
	      teamchars[planets[i].pl_owner]);
    }
}
